using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace LiveSamples
{
	/// <summary>
	/// Summary description for LiveProgress.
	/// </summary>
	public class LiveProgress : System.Web.UI.Page
	{
		protected Dart.LiveControls.LivePanel panelProgress;
		protected Dart.LiveControls.LivePanel panelProgressStatic;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox txtInterval;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox txtIncrement;
		protected Dart.LiveControls.LiveButton cmdStart;
		protected Dart.LiveControls.LiveButton cmdStop;
		protected Dart.LiveControls.LiveSound soundProgress;
		protected Dart.LiveControls.LiveSound soundProgressComplete;
		protected Dart.LiveControls.LiveSound soundProgressError;
		protected Dart.LiveControls.LiveTimer LiveTimer1;
	
		private const int FixedProgressWidth = 300;

		private void Page_Load(object sender, System.EventArgs e)
		{
			panelProgressStatic.Width = Unit.Pixel(FixedProgressWidth);
			if(!IsPostBack)
			{
				panelProgress.Width = Unit.Pixel(0);
				LiveTimer1.Blocking = true;
				cmdStop.Enabled = false;
				Session["ABORTED"] = false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			if (!this.DesignMode)
                InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.cmdStart.Click += new System.EventHandler(this.cmdStart_Click);
			this.cmdStop.Click += new System.EventHandler(this.cmdStop_Click);
			this.LiveTimer1.Tick += new System.EventHandler(this.LiveTimer1_Tick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LiveTimer1_Tick(object sender, System.EventArgs e)
		{
			if(!SetProgress())
			{
				panelProgress.Width = Unit.Pixel(0);
				txtInterval.Enabled = true;
				txtIncrement.Enabled = true;
				cmdStart.Enabled = true;
				cmdStop.Enabled = false;
				if((bool)Session["ABORTED"] == true)
					soundProgressError.Play();
				else
					soundProgressComplete.Play();
				LiveTimer1.Stop();
			}
			else
			{
				soundProgress.Play();
				try
				{
					LiveTimer1.Interval = Convert.ToInt16(txtInterval.Text);
				}
				catch{}
			}
		}

		private bool SetProgress()
		{
			int inc = 0;
			try
			{
				inc = Convert.ToInt16(txtIncrement.Text);
			}
			catch{}
			int pgMax = (int)panelProgressStatic.Width.Value;
			int pgPos = (int)panelProgress.Width.Value;

			if(((pgPos + inc) < pgMax) && !((bool)Session["ABORTED"]))
			{
				panelProgress.Width = Unit.Pixel(pgPos + inc);
				return true;
			}
			return false;
		}

		private void cmdStop_Click(object sender, System.EventArgs e)
		{
			cmdStop.Enabled = false;
			Session["ABORTED"] = true;
		}

		private void cmdStart_Click(object sender, System.EventArgs e)
		{
			Session["ABORTED"] = false;
			cmdStart.Enabled = false;
			cmdStop.Enabled = true;
			txtInterval.Enabled = false;
			txtIncrement.Enabled = false;
			LiveTimer1.EnableCallback = true;
			try
			{
				LiveTimer1.Interval = Convert.ToInt16(txtInterval.Text);
			}
			catch{}
			LiveTimer1.Start();
		}
	}
}
