using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Dart.LiveControls;

namespace LiveSamples
{
	/// <summary>
	/// Summary description for LiveShoppingCart.
	/// </summary>
	public class LiveShoppingCart : System.Web.UI.Page
	{
		protected Dart.LiveControls.LiveDropDownList ddMemory;
		protected Dart.LiveControls.LiveLabel lblMemory;
		protected Dart.LiveControls.LiveDropDownList ddCPU;
		protected Dart.LiveControls.LiveLabel lblCPU;
		protected Dart.LiveControls.LiveImageButton imgCase1;
		protected Dart.LiveControls.LiveImageButton imgCase2;
		protected Dart.LiveControls.LiveImageButton imgCase3;
		protected Dart.LiveControls.LiveLabel lblCase;
		protected Dart.LiveControls.LiveCheckBox chkModem;
		protected Dart.LiveControls.LiveLabel lblModem;
		protected Dart.LiveControls.LiveCheckBox chkNetworkCard;
		protected Dart.LiveControls.LiveLabel lblNetworkCard;
		protected Dart.LiveControls.LiveRadioButton rbWarranty1;
		protected Dart.LiveControls.LiveRadioButton rbWarranty2;
		protected Dart.LiveControls.LiveLabel lblWarranty;
		protected Dart.LiveControls.LiveLabel lblTotal;
		protected Dart.LiveControls.LiveButton cmdCheckOut;
		protected Dart.LiveControls.LiveMessageBox LiveMessageBox1;
		protected Dart.LiveControls.LiveButton cmdGetPrices;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack)
			{
				imgCase2_Click(this, null);
				GetAllPrices();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
            if (!this.DesignMode) 
                InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ddMemory.SelectedIndexChanged += new System.EventHandler(this.ddMemory_SelectedIndexChanged);
			this.ddCPU.SelectedIndexChanged += new System.EventHandler(this.ddCPU_SelectedIndexChanged);
			this.imgCase1.Click += new System.Web.UI.ImageClickEventHandler(this.imgCase1_Click);
			this.imgCase2.Click += new System.Web.UI.ImageClickEventHandler(this.imgCase2_Click);
			this.imgCase3.Click += new System.Web.UI.ImageClickEventHandler(this.imgCase3_Click);
			this.chkModem.CheckedChanged += new System.EventHandler(this.chkModem_CheckedChanged);
			this.chkNetworkCard.CheckedChanged += new System.EventHandler(this.chkNetworkCard_CheckedChanged);
			this.rbWarranty1.CheckedChanged += new System.EventHandler(this.rbWarranty1_CheckedChanged);
			this.rbWarranty2.CheckedChanged += new System.EventHandler(this.rbWarranty2_CheckedChanged);
			this.cmdGetPrices.Click += new System.EventHandler(this.cmdGetPrices_Click);
			this.cmdCheckOut.Click += new System.EventHandler(this.cmdCheckOut_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ddMemory_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			lblMemory.Text = "";
			GetMemoryPrice();
			GetTotal();
		}

		private void ddCPU_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			lblCPU.Text = "";
			GetCPUPrice();
			GetTotal();
		}

		private void cmdGetPrices_Click(object sender, System.EventArgs e)
		{
			GetAllPrices();
		}

		private void imgCase1_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			imgCase1.BorderStyle = BorderStyle.Solid;
			imgCase1.BorderColor = Color.Red;
			imgCase1.BorderWidth = Unit.Pixel(1);
			imgCase2.BorderStyle = BorderStyle.None;
			imgCase3.BorderStyle = BorderStyle.None;
			GetCasePrice();
			GetTotal();		
		}

		private void imgCase2_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			imgCase1.BorderStyle = BorderStyle.None;
			imgCase2.BorderStyle = BorderStyle.Solid;
			imgCase2.BorderColor = Color.Red;
			imgCase2.BorderWidth = Unit.Pixel(1);
			imgCase3.BorderStyle = BorderStyle.None;
			GetCasePrice();
			GetTotal();
		}

		private void imgCase3_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			imgCase1.BorderStyle = BorderStyle.None;
			imgCase2.BorderStyle = BorderStyle.None;
			imgCase3.BorderStyle = BorderStyle.Solid;
			imgCase3.BorderColor = Color.Red;
			imgCase3.BorderWidth = Unit.Pixel(1);
			GetCasePrice();
			GetTotal();
		}

		private void chkModem_CheckedChanged(object sender, System.EventArgs e)
		{
			GetModemPrice();
			GetTotal();
		}

		private void chkNetworkCard_CheckedChanged(object sender, System.EventArgs e)
		{
			GetNetworkCardPrice();
			GetTotal();
		}

		private void rbWarranty1_CheckedChanged(object sender, System.EventArgs e)
		{
			GetWarrantyPrice();
			GetTotal();
		}

		private void rbWarranty2_CheckedChanged(object sender, System.EventArgs e)
		{
			GetWarrantyPrice();
			GetTotal();
		}

		private void GetAllPrices()
		{
			GetMemoryPrice();
			GetCPUPrice();
			GetModemPrice();
			GetNetworkCardPrice();
			GetWarrantyPrice();
			GetCasePrice();
			GetTotal();
		}

		private void GetModemPrice()
		{
			if(chkModem.Checked)
				lblModem.Text = (14.99).ToString("C");
			else
				lblModem.Text = (0).ToString("C");
		}

		private void GetNetworkCardPrice()
		{
			if(chkNetworkCard.Checked)
				lblNetworkCard.Text = (27.99).ToString("C");
			else
				lblNetworkCard.Text = (0).ToString("C");
		}

		private void GetWarrantyPrice()
		{
			if(rbWarranty1.Checked)
				lblWarranty.Text = (0).ToString("C");
			else
				lblWarranty.Text = (149.99).ToString("C");
		}

		private void GetCasePrice()
		{
			if(imgCase1.BorderStyle != BorderStyle.None)
				lblCase.Text = "$38.75";
			if(imgCase2.BorderStyle != BorderStyle.None)
				lblCase.Text = "$62.95";
			if(imgCase3.BorderStyle != BorderStyle.None)
				lblCase.Text = "$82.50";
		}

		private void GetTotal()
		{
			double total = 0;

			total += GetDoubleFromLabel(lblWarranty);
			total += GetDoubleFromLabel(lblNetworkCard);
			total += GetDoubleFromLabel(lblModem);
			total += GetDoubleFromLabel(lblCPU);
			total += GetDoubleFromLabel(lblMemory);
			total += GetDoubleFromLabel(lblCase);
			lblTotal.Text = total.ToString("C");
		}

		private double GetDoubleFromLabel(LiveLabel Label)
		{
			try
			{
				return Convert.ToDouble(Label.Text.Replace("$", "").Replace(",", ""));
			}
			catch
			{
				return 0.0;
			}
		}

		private void GetMemoryPrice()
		{
			// If there is no selected item, do nothing
			if(ddMemory.SelectedItem == null)
				return;

			// If currentprice = 0 then this is first time
			// otherwise determine a random price based on 
			// the current
			double startprice = GetDoubleFromLabel(lblMemory);
			
			if(startprice == 0)
			{
				switch(ddMemory.SelectedItem.Text)
				{
					case "64M":
						startprice = 8.23;
						break;
					case "128M":
						startprice = 16.46;
						break;
					case "256M":
						startprice = 49.67;
						break;
					case "512M":
						startprice = 86.23;
						break;
					case "1G":
						startprice = 128.23;
						break;
				}
			}

			// Set the current price to the startprice
			double currentprice = startprice;

			// Pick a random number between 1 and 3. 
			// If result is 1, then perform a simulated price change
			if(LiveShared.GetRandomNumber(1, 3) == 1)
			{
				bool increase = true;
				if(LiveShared.GetRandomNumber(0, 1) == 0)
					increase = false;

				// Determine the current price (between 1% and 5% of the start)
				double factor = LiveShared.GetRandomNumber(1, 5) / 100.0;
				if(increase)
					factor = 1 + factor;
				else
					factor = 1 - factor;
				currentprice *= factor;
			}

			// Set the current price
			lblMemory.Text = currentprice.ToString("C");
		}

		private void GetCPUPrice()
		{
			// If there is no selected item, do nothing
			if(ddCPU.SelectedItem == null)
				return;

			// If currentprice = 0 then this is first time
			// otherwise determine a random price based on 
			// the current
			double startprice = GetDoubleFromLabel(lblCPU);

			if(startprice == 0)
			{
				switch(ddCPU.SelectedItem.Text)
				{
					case "2000 Mhz":
						startprice = 136.99;
						break;
					case "2200 Mhz":
						startprice = 212.23;
						break;
					case "3200 Mhz":
						startprice = 328.76;
						break;
					case "8800 Mhz":
						startprice = 6892.32;
						break;
				}
			}

			// Set the current price to the startprice
			double currentprice = startprice;

			// Pick a random number between 1 and 3. 
			// If result is 1, then perform a simulated price change
				if(LiveShared.GetRandomNumber(1, 3) == 1)
				{
					bool increase = true;
					if(LiveShared.GetRandomNumber(0, 1) == 0)
						increase = false;

					// Determine the current price (between 1% and 5% of the start)
					double factor = LiveShared.GetRandomNumber(1, 5) / 100.0;
					if(increase)
						factor = 1 + factor;
					else
						factor = 1 - factor;
					currentprice *= factor;
				}

			// Set the current price
			lblCPU.Text = currentprice.ToString("C");
		}

		private void cmdCheckOut_Click(object sender, System.EventArgs e)
		{
			string msg = "Your total is " + GetDoubleFromLabel(lblTotal).ToString("C");
			msg += ". Thank you for your order!";
			LiveMessageBox1.Show(msg,DialogType.Alert);
		}
	}
}
