Imports System.Collections
Imports System.ComponentModel
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports Dart.LiveControls

Namespace LiveSamples
	''' <summary>
	''' Summary description for LiveAuction.
	''' </summary>
	Public Class LiveAuction
		Inherits System.Web.UI.Page

		Protected lblTitle As Dart.LiveControls.LiveLabel
		Protected lblAbout As Dart.LiveControls.LiveLabel
		Protected WithEvents cmdStart As Dart.LiveControls.LiveButton
		Protected panelAbout As Dart.LiveControls.LivePanel
		Protected WithEvents LiveImageButton1 As Dart.LiveControls.LiveImageButton
		Protected lblCurrentBid As Dart.LiveControls.LiveLabel
		Protected lblTimeLeft As Dart.LiveControls.LiveLabel
		Protected lblStartTime As Dart.LiveControls.LiveLabel
		Protected lblHistory As Dart.LiveControls.LiveLabel
		Protected lblHighBidder As Dart.LiveControls.LiveLabel
		Protected panelAuctionInfo As Dart.LiveControls.LivePanel
		Protected LiveMessageBox1 As Dart.LiveControls.LiveMessageBox
		Protected WithEvents LiveTimer1 As Dart.LiveControls.LiveTimer

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			If Not IsPostBack Then
				Session("StartTime") = Nothing
				Session("EndTime") = Nothing
				Dim s As String = "This sample simulates the last 2 minutes of an online auction. Click 'Start Simulation' to start. <p>"
				s &= "Once started, this page will change into a page resembling that of a well-known auction site. <p>"
				s &= "The difference between this page and others is that the information is updated in real time using a LiveTimer control."
				lblAbout.Text = s
				lblTitle.Text = "LiveAuction Sample"
				panelAuctionInfo.Visible = False
				lblHighBidder.ForeColor = Color.Black
			End If
		End Sub

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			If Not Me.DesignMode Then
				InitializeComponent()
			End If
			MyBase.OnInit(e)
		End Sub

		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.cmdStart.Click += New System.EventHandler(Me.cmdStart_Click)
'			Me.LiveImageButton1.Click += New System.Web.UI.ImageClickEventHandler(Me.LiveImageButton1_Click)
'			Me.LiveTimer1.Tick += New System.EventHandler(Me.LiveTimer1_Tick)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		Private Sub cmdStart_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdStart.Click
			' Hide the about panel
			panelAbout.Visible = False
			' Show the auction panel
			panelAuctionInfo.Visible = True
			' Set simulated end time to 2 minutes from now
			Session("EndTime") = Date.Now.Add(New TimeSpan(0, 2, 0))
			' Calculate simulated start time (5 days before end)
			Session("StartTime") = CDate(Session("EndTime")).Subtract(New TimeSpan(5, 0, 0, 0))
			' Set the labels so that it looks like the auction is almost over
			lblTitle.Text = "1952 Original Fender Telecaster"
			lblStartTime.Text = CDate(Session("StartTime")).ToLongDateString() & " " & CDate(Session("StartTime")).ToLongTimeString()
			lblCurrentBid.Text = "US $4,320.00"
			lblHistory.Text = "27 bids"
			lblHighBidder.Text = GetHighBidder()
			lblTimeLeft.Text = "00:02:00"
			' Start the LiveTimer
			LiveTimer1.Blocking = True
			LiveTimer1.Interval = 500
			LiveTimer1.Start()
		End Sub

		Private Function GetHighBidder() As String
			Select Case LiveShared.GetRandomNumber(0, 5)
				Case 0
					Return "livectrl_guru"
				Case 1
					Return "fenderman"
				Case 2
					Return "teleluvr"
				Case 3
					Return "coder229"
				Case 4
					Return "freddy342"
				Case 5
					Return "soccermom62"
			End Select
			Return ""
		End Function

		Private Sub EndAuction()
			' Set the labels for the end of the auction
			lblTimeLeft.Text = "Ended"
			lblHighBidder.ForeColor = Color.DarkRed
		End Sub

		Private Sub RecordRandomBid()
			' Pick a random number between 0 and 6. If it's not 0 there was no bid
			If LiveShared.GetRandomNumber(0, 6) <> 0 Then
				Return
			End If
			' Determine the current bid (between 1% and 5% of the current)
			Dim RaiseFactor As Double = 1 + (LiveShared.GetRandomNumber(1, 5) / CDbl(100))
			Dim TotalBids As Integer = 0
			Try
				TotalBids = Convert.ToInt32(lblHistory.Text.Replace(" bids", "")) + 1
			Catch
			End Try
			Dim CurrentBid As Double = 0
			Try
				Dim s As String = lblCurrentBid.Text.Replace("US $", "").Replace(",", "")
				CurrentBid = CDbl(Convert.ToDecimal(s))
			Catch
			End Try
			CurrentBid *= RaiseFactor
			lblCurrentBid.Text = "US " & CurrentBid.ToString("C")
			' Set the number of bids
			lblHistory.Text = TotalBids.ToString() & " bids"
			' Set the high bidder
			lblHighBidder.Text = GetHighBidder()
		End Sub

		Private Sub LiveImageButton1_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles LiveImageButton1.Click
			' Show a LiveMessageBox when the user clicks the LiveImageButton
			LiveMessageBox1.Show("You just clicked a LiveImageButton! Had this been a real site instead of some cheesy demo, surely something really awesome would have happened!", DialogType.Alert)
		End Sub

		Private Sub LiveTimer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LiveTimer1.Tick
			' Stop the timer. The timer will only be restarted if the Auction is not over
			LiveTimer1.Stop()
			' Determine how much time is remaining
			Dim TimeLeft As New TimeSpan(CDate(Session("EndTime")).Ticks - Date.Now.Ticks)
			If TimeLeft.Ticks > 0 Then
				' Set the time left LiveLabel
				lblTimeLeft.Text = TimeLeft.Hours.ToString("D2") & ":" & TimeLeft.Minutes.ToString("D2") & ":" & TimeLeft.Seconds.ToString("D2")
				' Record a simulated bid
				RecordRandomBid()
				' Restart the Timer
				LiveTimer1.Start()
			Else
				' The auction is over now
				EndAuction()
			End If
		End Sub
	End Class
End Namespace
