Imports System.Collections
Imports System.ComponentModel
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

Namespace LiveSamples
	''' <summary>
	''' Summary description for LiveProgress.
	''' </summary>
	Public Class LiveProgress
		Inherits System.Web.UI.Page

		Protected panelProgress As Dart.LiveControls.LivePanel
		Protected panelProgressStatic As Dart.LiveControls.LivePanel
		Protected Label1 As System.Web.UI.WebControls.Label
		Protected txtInterval As System.Web.UI.WebControls.TextBox
		Protected Label2 As System.Web.UI.WebControls.Label
		Protected txtIncrement As System.Web.UI.WebControls.TextBox
		Protected WithEvents cmdStart As Dart.LiveControls.LiveButton
		Protected WithEvents cmdStop As Dart.LiveControls.LiveButton
		Protected soundProgress As Dart.LiveControls.LiveSound
		Protected soundProgressComplete As Dart.LiveControls.LiveSound
		Protected soundProgressError As Dart.LiveControls.LiveSound
		Protected WithEvents LiveTimer1 As Dart.LiveControls.LiveTimer

		Private Const FixedProgressWidth As Integer = 300

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			panelProgressStatic.Width = Unit.Pixel(FixedProgressWidth)
			If Not IsPostBack Then
				panelProgress.Width = Unit.Pixel(0)
				LiveTimer1.Blocking = True
				cmdStop.Enabled = False
				Session("ABORTED") = False
			End If
		End Sub

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			If Not Me.DesignMode Then
				InitializeComponent()
			End If
			MyBase.OnInit(e)
		End Sub

		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.cmdStart.Click += New System.EventHandler(Me.cmdStart_Click)
'			Me.cmdStop.Click += New System.EventHandler(Me.cmdStop_Click)
'			Me.LiveTimer1.Tick += New System.EventHandler(Me.LiveTimer1_Tick)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		Private Sub LiveTimer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LiveTimer1.Tick
			If Not SetProgress() Then
				panelProgress.Width = Unit.Pixel(0)
				txtInterval.Enabled = True
				txtIncrement.Enabled = True
				cmdStart.Enabled = True
				cmdStop.Enabled = False
				If CBool(Session("ABORTED")) = True Then
					soundProgressError.Play()
				Else
					soundProgressComplete.Play()
				End If
				LiveTimer1.Stop()
			Else
				soundProgress.Play()
				Try
					LiveTimer1.Interval = Convert.ToInt16(txtInterval.Text)
				Catch
				End Try
			End If
		End Sub

		Private Function SetProgress() As Boolean
			Dim inc As Integer = 0
			Try
				inc = Convert.ToInt16(txtIncrement.Text)
			Catch
			End Try
			Dim pgMax As Integer = CInt(Fix(panelProgressStatic.Width.Value))
			Dim pgPos As Integer = CInt(Fix(panelProgress.Width.Value))

			If ((pgPos + inc) < pgMax) AndAlso Not(CBool(Session("ABORTED"))) Then
				panelProgress.Width = Unit.Pixel(pgPos + inc)
				Return True
			End If
			Return False
		End Function

		Private Sub cmdStop_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdStop.Click
			cmdStop.Enabled = False
			Session("ABORTED") = True
		End Sub

		Private Sub cmdStart_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdStart.Click
			Session("ABORTED") = False
			cmdStart.Enabled = False
			cmdStop.Enabled = True
			txtInterval.Enabled = False
			txtIncrement.Enabled = False
			LiveTimer1.EnableCallback = True
			Try
				LiveTimer1.Interval = Convert.ToInt16(txtInterval.Text)
			Catch
			End Try
			LiveTimer1.Start()
		End Sub
	End Class
End Namespace
