Imports System.IO
Imports System.Collections
Imports System.ComponentModel
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

Namespace LiveSamples
	''' <summary>
	''' Summary description for LiveSlideShow.
	''' </summary>
	Public Class LiveSlideShow
		Inherits System.Web.UI.Page

		Private baseURL As String
		Protected WithEvents liNowShowing As Dart.LiveControls.LiveImage
		Protected LivePanel1 As Dart.LiveControls.LivePanel
		Protected WithEvents lddlSlides As Dart.LiveControls.LiveDropDownList
		Protected WithEvents lbPlay As Dart.LiveControls.LiveImageButton
		Protected WithEvents lbPause As Dart.LiveControls.LiveImageButton
		Protected WithEvents lbPrevious As Dart.LiveControls.LiveImageButton
		Protected WithEvents lbNext As Dart.LiveControls.LiveImageButton
		Protected WithEvents ldgSlides As Dart.LiveControls.LiveDataGrid
		Protected imgPlay As System.Web.UI.WebControls.Image
		Protected imgPause As System.Web.UI.WebControls.Image
		Protected imgPrev As System.Web.UI.WebControls.Image
		Protected imgNext As System.Web.UI.WebControls.Image
		Protected WithEvents LiveTimer1 As Dart.LiveControls.LiveTimer

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			baseURL = Request.ApplicationPath & "/"
			If baseURL.StartsWith("//") Then
				baseURL = baseURL.Replace("//", "/")
			End If
			If Not Page.IsPostBack Then
				lbPlay.AccessKey = "N"
				lbPlay.ToolTip = "Play"
				lbPlay.ImageUrl = getUrlString("images/play.jpg")
				imgPlay.ImageUrl = lbPlay.ImageUrl

				lbPause.AccessKey = "M"
				lbPause.ToolTip = "Pause"
				lbPause.ImageUrl = getUrlString("images/pause.jpg")
				imgPause.ImageUrl = lbPause.ImageUrl

				lbPrevious.AccessKey = "<"
				lbPrevious.ToolTip = "Previous"
				lbPrevious.ImageUrl = getUrlString("images/previous.jpg")
				imgPrev.ImageUrl = lbPrevious.ImageUrl

				lbNext.AccessKey = ">"
				lbNext.ToolTip = "Next"
				lbNext.ImageUrl = getUrlString("images/next.jpg")
				imgNext.ImageUrl = lbNext.ImageUrl

				'build initial list of images
				RefreshImageList()
				DrawPage()
				InitTimer()
			End If
		End Sub


		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			If Not Me.DesignMode Then
				InitializeComponent()
			End If
			MyBase.OnInit(e)
		End Sub

		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			liNowShowing.DoubleClick += New Dart.LiveControls.LocationEventHandler(liNowShowing_DoubleClick)
'			lddlSlides.SelectedIndexChanged += New System.EventHandler(lddlSlides_SelectedIndexChanged)
'			lbPlay.Click += New System.Web.UI.ImageClickEventHandler(lbPlay_Click)
'			lbPause.Click += New System.Web.UI.ImageClickEventHandler(lbPause_Click)
'			lbPrevious.Click += New System.Web.UI.ImageClickEventHandler(lbPrevious_Click)
'			lbNext.Click += New System.Web.UI.ImageClickEventHandler(lbNext_Click)
'			ldgSlides.ItemCommand += New System.Web.UI.WebControls.DataGridCommandEventHandler(ldgSlides_ItemCommand)
'			ldgSlides.PageIndexChanged += New System.Web.UI.WebControls.DataGridPageChangedEventHandler(ldgSlides_PageIndexChanged)
'			LiveTimer1.Tick += New System.EventHandler(LiveTimer1_Tick)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		#Region "Initialization"
		Private Sub InitTimer()
			LivePanel1.BackColor = Color.White
			LivePanel1.Height = liNowShowing.Height
			TimerCount = 0
		End Sub
		Private Sub RefreshImageList()
			Dim SlidePath As String = Server.MapPath(getUrlString("slides"))
			Dim d As New DirectoryInfo(SlidePath)

			'prep dataset
			If SlideData.Tables.Count = 0 Then
				Dim dt As DataTable = SlideData.Tables.Add("Images")
				dt.Columns.Add("url")
				dt.Columns.Add("name")
				dt.Columns.Add("size")

				'load data
				For Each f As FileInfo In d.GetFiles()
					If (f.Name.ToUpper().EndsWith("JPG")) OrElse (f.Name.ToUpper().EndsWith("GIF")) Then
						SlidesArray.Add(f.Name)
						dt.Rows.Add(New Object(){getUrlString("slides/") & f.Name, f.Name, (f.Length\1024) & "KB"})
					End If
				Next f
			End If
			SlideIndex = 0
			PageIndex = 0
			ShowImage()
			lddlSlides.DataSource = SlidesArray
			lddlSlides.DataBind()
		End Sub
		#End Region

		#Region "Event Handlers"
		Private Sub lbPlay_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles lbPlay.Click
			If lbPlay.ImageUrl.ToLower() = getUrlString("images/play-selected.jpg") Then
				Return
			End If
			lbPlay.ImageUrl = getUrlString("images/play-selected.jpg")
			lbPause.ImageUrl = getUrlString("images/pause.jpg")
			DrawTimer()
			LiveTimer1.Start()
		End Sub
		Private Sub lbPause_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles lbPause.Click
			If lbPause.ImageUrl.ToLower() = getUrlString("images/pause-selected.jpg") Then
				Return
			End If
			lbPause.ImageUrl = getUrlString("images/pause-selected.jpg")
			lbPlay.ImageUrl = getUrlString("images/play.jpg")
			LiveTimer1.Stop()
		End Sub
		Private Sub LiveTimer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LiveTimer1.Tick
			TimerCount += 1
			If TimerCount >= 5 Then
				TimerCount = 0
				Shuttle(1)
			End If
			DrawTimer()
		End Sub

		Private Sub liNowShowing_DoubleClick(ByVal sender As Object, ByVal e As Dart.LiveControls.LocationEventArgs) Handles liNowShowing.DoubleClick
			Shuttle(1)
		End Sub

		Private Sub lbPrevious_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles lbPrevious.Click
			Shuttle(-1)
		End Sub

		Private Sub lbNext_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles lbNext.Click
			Shuttle(1)
		End Sub

		Private Sub ldgSlides_ItemCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles ldgSlides.ItemCommand
			SlideIndex = (PageIndex * ldgSlides.PageSize) + e.Item.ItemIndex
			ShowImage()
		End Sub
		Private Sub ldgSlides_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles ldgSlides.PageIndexChanged

			PageIndex = e.NewPageIndex
			Dim lowerLimit As Integer = (PageIndex * ldgSlides.PageSize)
			If (SlideIndex >= lowerLimit) AndAlso (SlideIndex < (lowerLimit+ldgSlides.PageSize)) Then
				ldgSlides.SelectedIndex = GridIndex
			Else
				ldgSlides.SelectedIndex = -1
			End If
			DrawPage()

		End Sub
		Private Sub lddlSlides_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lddlSlides.SelectedIndexChanged
			SlideIndex = lddlSlides.SelectedIndex
			ShowImage()
		End Sub
		#End Region

		#Region "private Methods"
		Private Sub Shuttle(ByVal move As Integer)
			If SlidesExist Then
				SlideIndex += move
				If SlideIndex < 0 Then
					SlideIndex = SlidesArray.Count - 1
				End If
				If SlideIndex > (SlidesArray.Count - 1) Then
					SlideIndex = 0
				End If
				ShowImage()
			End If
		End Sub

		Private Sub ShowImage()
			ldgSlides.SelectedIndex = GridIndex
			Dim url As String = getSlideUrl(SlideIndex)
			If url IsNot Nothing Then
				liNowShowing.ImageUrl = url
				liNowShowing.Visible = True
				InitTimer()
				If LiveTimer1.Enabled Then
					DrawTimer()
				End If
				SetPage()
				If lddlSlides.SelectedIndex <> SlideIndex Then
					lddlSlides.SelectedIndex = SlideIndex
				End If
			End If
		End Sub

		Private Sub SetPage()
			Dim curPageIndex As Integer = PageIndex
			Dim newPageIndex As Integer
			If SlideIndex < ldgSlides.PageSize Then
				newPageIndex = 0
			Else
				newPageIndex = (SlideIndex \ ldgSlides.PageSize)
			End If
			If newPageIndex <> curPageIndex Then
				PageIndex = newPageIndex
				DrawPage()
			End If
		End Sub
		Private Sub DrawPage()
			ldgSlides.DataSource = SlideData
			ldgSlides.CurrentPageIndex = PageIndex
			ldgSlides.DataBind()
		End Sub

		Private Sub DrawTimer()
			LivePanel1.BackColor = Color.Tomato
			Dim cnt As Integer = TimerCount
			Dim size As Integer = CInt(Fix(liNowShowing.Height.Value - (cnt * (liNowShowing.Height.Value/4))))
			If size > 0 Then
				LivePanel1.Height = New Unit(size,UnitType.Pixel)
			Else
				LivePanel1.BackColor = Color.White
			End If
		End Sub

		Private Function getSlideUrl(ByVal index As Integer) As String
			Dim f As String = getSlideFile(index)
			If f Is Nothing Then
				Return f
			End If
			Return getUrlString("/slides/") & f
		End Function

		Private Function getSlideFile(ByVal index As Integer) As String
			If (SlidesArray.Count > 0) AndAlso (index < SlidesArray.Count) Then
				Dim slide As String = CStr(SlidesArray(index))
				If slide.StartsWith("/") Then
					Return slide.Remove(0,1)
				Else
					Return slide
				End If
			Else
				Return Nothing
			End If
		End Function

		Private Function getUrlString(ByVal relUrl As String) As String
			If relUrl.StartsWith("/") Then
				relUrl = relUrl.Remove(0,1)
			End If
			relUrl = baseURL & relUrl
			Return relUrl
		End Function
		#End Region

		#Region "public Properties"
		Public Property PageIndex() As Integer
			Get
				Return CInt(Fix(Session("LiveControls.SlideShowCS.PageIndex")))
			End Get
			Set(ByVal value As Integer)
				Session("LiveControls.SlideShowCS.PageIndex") = value
			End Set
		End Property

		Public Property SlideIndex() As Integer
			Get
				Return CInt(Fix(Session("LiveControls.SlideShowCS.SlideIndex")))
			End Get
			Set(ByVal value As Integer)
				Session("LiveControls.SlideShowCS.SlideIndex") = value
			End Set
		End Property

		Public Property TimerCount() As Integer
			Get
				Return CInt(Fix(Session("LiveControls.SlideShowCS.TimerCount")))
			End Get
			Set(ByVal value As Integer)
				Session("LiveControls.SlideShowCS.TimerCount") = value
			End Set
		End Property

		Public ReadOnly Property SlidesArray() As ArrayList
			Get
				Dim al As ArrayList = CType(Session("LiveControls.SlideShowCS.SlidesArray"), ArrayList)
				If al Is Nothing Then
					al = New ArrayList()
					Session("LiveControls.SlideShowCS.SlidesArray") = al
				End If
				Return al
			End Get
		End Property
		Public ReadOnly Property SlidesExist() As Boolean
			Get
				Return (SlidesArray.Count > 0)
			End Get
		End Property
		Public ReadOnly Property GridIndex() As Integer
			Get
				Return SlideIndex Mod ldgSlides.PageSize
			End Get
		End Property
		Public ReadOnly Property SlideData() As DataSet
			Get
				Dim ds As DataSet = CType(Session("LiveControls.SlideShowCS.SlidesDS"), DataSet)
				If ds Is Nothing Then
					ds = New DataSet()
					Session("LiveControls.SlideShowCS.SlidesDS") = ds
				End If
				Return ds
			End Get
		End Property
		#End Region
	End Class
End Namespace
