using System;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using Dart.LiveControls;

namespace LiveTutorial
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class _default : System.Web.UI.Page
	{
		protected Dart.LiveControls.LivePlaceHolder plcContent;
		protected Dart.LiveControls.LiveLinkButton lnkViewSource;
		protected Dart.LiveControls.LiveTextBox lblCode;
		protected Dart.LiveControls.LiveLinkButton lnkViewServerTags;
		protected Dart.LiveControls.LiveTextBox lblViewServerTags;
		protected Dart.LiveControls.LiveLabel lblHeading;
		protected Dart.LiveControls.LiveSound CallbackTester;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;
		protected Dart.LiveControls.LiveSound LiveSound1;
		protected Dart.LiveControls.LiveLabel lblControlsUsed;
	
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			if (!this.DesignMode) 
                InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lnkViewServerTags.Command += new System.Web.UI.WebControls.CommandEventHandler(this.lnkViewServerTags_Command);
			this.lnkViewSource.Command += new System.Web.UI.WebControls.CommandEventHandler(this.lnkViewSource_Command);
			this.Load += new System.EventHandler(this.Page_Load);
			this.Init += new System.EventHandler(this._default_Init);
			this.PreRender += new System.EventHandler(this._default_PreRender);

		}
		#endregion

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack)
			{
				Session["DataBaseError"] = "";
				Session["DataBasePath"] = Server.MapPath("data/northwind.mdb");
				Session["DataBaseCommand"] = null;
			}
			//Page.Request.SaveAs("C:\\temp\\post.txt", true);
		}

		private void LoadMenu()
		{
			string path = Server.MapPath("");
			path += "\\tutorials";

			string[] directories = Directory.GetDirectories(path);

			foreach(string directory in directories)
				GetMenuItems(directory);
		}
		
		public string GetMenuItems(string dir)
		{
			string dirName = new DirectoryInfo(dir).Name;
			LiveLabel label = new LiveLabel();
			if(plcContent.BrowserType == BrowserType.Mozilla)
				label.Text = "<br><br><p><b>" + CapsFirstLetters(dirName) + "</b>";
			else
				label.Text = "<p><b>" + CapsFirstLetters(dirName) + "</b>";
			PlaceHolder1.Controls.Add(label);

			string[] files = Directory.GetFiles(dir);
			string items = "";

			foreach(string file in files)
			{
				FileInfo fileInfo = new FileInfo(file);
				if(fileInfo.Extension == ".ascx")
				{
					PlaceHolder1.Controls.Add(new LiteralControl("<br>&nbsp&nbsp&nbsp"));
					LiveLinkButton link = new LiveLinkButton();
					string text = CapsFirstLetters(fileInfo.Name.Replace(fileInfo.Extension, ""));
					text = text.Split(')')[1].Substring(1, text.Split(')')[1].Length - 1);
					if(text.StartsWith("What Are") || 
						text.StartsWith("How Do"))text += "?";
					link.Text = text;
					link.CommandName = QuickEncode(text);
					link.CommandArgument = QuickEncode(dirName) + "/" + fileInfo.Name;
					if ((string)Session["UserControl"] != link.CommandArgument)
						link.Command+= new CommandEventHandler(this.menu_Command);
					PlaceHolder1.Controls.Add(link);
				}
			}
			return items;
		}

		
		private void menu_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			LoadUserControl(QuickDecode((string)e.CommandArgument));
			SetHeading(QuickDecode(e.CommandName));
		}
		
		private void SetHeading(string heading)
		{
			Session["Heading"] = heading;
			lblHeading.Text = "<h4 class='heading'>" + heading + "</h5>";
		}

		private string CapsFirstLetters(string str)
		{
			if(str == "" || str == null) return str;
			string[] strParts = str.Split('_');
			string[] newParts = new string[strParts.Length];
			for(int i=0; i<strParts.Length; i++)
			{
				string strPart = strParts[i];
				if(!strPart.EndsWith(")"))
					newParts[i] = strPart.ToUpper().Substring(0, 1) + strPart.Substring(1, strPart.Length - 1);
				else
					newParts[i] = strPart;
			}
			str = "";
			foreach(string newPart in newParts)
				str+= newPart + " ";
			return str.Substring(0, str.Length -1);
		}

		private void LoadUserControl(string controlPath)
		{
			bool newLoad = false;
			Session["PrevControl"] = Session["UserControl"];
			Session["UserControl"] = controlPath;
			plcContent.Controls.Clear();
			try
			{
				string controlFullPath = "tutorials/" + controlPath;
				UserControl control = (UserControl)this.LoadControl(controlFullPath);
				if(Session["UserControl"] != null && Session["PrevControl"] != null)
				{
					if((string)Session["UserControl"] != (string)Session["PrevControl"])
						newLoad = true;
				}
				else
					newLoad = true;
				if(control is LiveUserControl)
					((LiveUserControl)control).NewLoad = newLoad;

				if(newLoad && Page.IsPostBack)
				{
					ShowCode(null, lnkViewSource, lblCode, "View Code-Behind Source");
					ShowCode(null, lnkViewServerTags, lblViewServerTags, "View ASPX Source");
				}

				//control.ID = "LiveUserControl";
				control.ID = controlPath;
				SetServerControlsUsed((LiveUserControl)control);
				plcContent.Controls.Add(control);
				plcContent.IsLive = newLoad;
				lnkViewSource.Visible = lnkViewServerTags.Visible = true;
				lnkViewSource.CommandName = lnkViewServerTags.CommandName = "LoadControl";
				lnkViewServerTags.CommandArgument = controlFullPath;
				lnkViewSource.CommandArgument = controlFullPath + ".cs";
			}
			catch(Exception ex)
			{
				Label errorLabel = new Label();
				errorLabel.Text = "Unable to load page content. Error reported by server:<br><br>" + ex.ToString();
				plcContent.Controls.Add(errorLabel);
				lnkViewSource.Visible = lnkViewServerTags.Visible = false;
				lnkViewSource.CommandName = lnkViewServerTags.CommandName = "";
				lnkViewSource.CommandArgument = lnkViewSource.CommandArgument = "";
				lblControlsUsed.Text = "";
			}
		}

		public void SetServerControlsUsed(LiveUserControl control)
		{
			ArrayList usedControls = new ArrayList();
			ArrayList liveControls = control.GetLiveControls();
			foreach(ILiveControl liveControl in liveControls)
			{
				bool found = false;
				foreach(string str in usedControls)
				{
					if(str == liveControl.GetType().Name)
						found = true;
				}
				if(!found) usedControls.Add(liveControl.GetType().Name);
			}

			usedControls.Sort();
			string list = "<ul>";
			foreach(string str in usedControls)
				list+= "<li>" + str;
			list+= "</ul>";
			lblControlsUsed.Text = "";
			lblControlsUsed.Text = list;
		}


		private void lnkViewSource_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			ShowCode(e, (LiveLinkButton)sender, lblCode, "View Code-Behind Source");
		}

		private void lnkViewServerTags_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			ShowCode(e, (LiveLinkButton)sender, lblViewServerTags, "View ASPX Source");
		}

		private void ShowCode(CommandEventArgs e, LiveLinkButton button, LiveTextBox label, string txt)
		{
			if(e != null)
			{
				if(e.CommandName != "LoadControl") return;
			}
			if(label.Visible || e == null)
			{
				button.Text = "<img src=images/expand.gif align=absmiddle border=0> <b>" + txt + ":</b>";
				label.Visible = false;
				label.Text = "";
			}
			else
			{
				button.Text = "<img src=images/contract.gif align=absmiddle border=0> <b>" + txt + ":</b>";
				label.Visible = true;
				string path = Server.MapPath("");
				path += "\\" + e.CommandArgument.ToString();
				label.Text = GetFileText(path);
			}
		}

		private string GetFileText(string path)
		{
			try
			{
				FileStream fStream = new FileStream(path, FileMode.Open, FileAccess.Read);
				StreamReader reader = new StreamReader(fStream);
				string text = reader.ReadToEnd();
				fStream.Close();
				// Return straight text found in file. 
				return text;
			}
			catch
			{
				FileInfo fil = new FileInfo(path);
				return "Unable to access source code. Please be sure the ASPNET account has proper access rights to the file " + fil.FullName+ ". To avoid seeing this error again while using this application, you may want to set access rights on the entire directory at " + fil.Directory.Parent.FullName + ".";
			}
		}


		private string QuickEncode(string text)
		{
			return text.Replace(" ", "%20");
		}

		private string QuickDecode(string text)
		{
			return text.Replace("%20", " ");
		}

		private void _default_Init(object sender, System.EventArgs e)
		{
			LoadMenu();
			if(!Page.IsPostBack)
			{
				LoadUserControl("1)_overview/a)_what_are_live_controls.ascx");
				SetHeading("What Are Live Controls?");
			}
			else
			{
				// Reload stuff from session
				LoadUserControl((string)Session["UserControl"]);
				SetHeading((string)Session["Heading"]);
			}
		}

		protected override object LoadPageStateFromPersistenceMedium()
		{
			object state = this.Session["DisplayState"];
			return state;
		}
		
		protected override void SavePageStateToPersistenceMedium(object viewState)
		{
			this.Session.Add("DisplayState", viewState);
		}

		private void _default_PreRender(object sender, System.EventArgs e)
		{
			if(Session["UserControl"] == Session["PrevControl"])
				plcContent.IsLive = false;
			else
				plcContent.IsLive = true;
		}
	}
}
