namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using Dart.LiveControls;
	using System.Collections;

	public enum View
	{
		Contacts,
		Activities,
		Email,
		Styles
	}

	/// <summary>
	///		Summary description for using_LiveControls.
	/// </summary>
	public abstract class using_LiveControls : LiveUserControl
	{
		protected Dart.LiveControls.LiveImageButton btnActivities;
		protected Dart.LiveControls.LiveImageButton btnEmail;
		protected Dart.LiveControls.LiveImageButton btnStyles;
		protected Dart.LiveControls.LivePanel pnlContacts;
		protected Dart.LiveControls.LivePanel pnlActivities;
		protected Dart.LiveControls.LivePanel pnlEmail;
		protected Dart.LiveControls.LivePanel pnlStyles;
		protected Dart.LiveControls.LiveLabel lblContactsTitle;
		protected Dart.LiveControls.LiveLabel lblActivitiesTitle;
		protected Dart.LiveControls.LiveLabel lblEmailTitle;
		protected Dart.LiveControls.LiveLabel lblStylesTitle;
		protected Dart.LiveControls.LiveDropDownList ddStyles;
		protected Dart.LiveControls.LiveDropDownList ddIconSize;
		protected Dart.LiveControls.LiveDropDownList ddFontFace;
		protected Dart.LiveControls.LiveLinkButton btnMessage1;
		protected Dart.LiveControls.LiveLinkButton btnMessage2;
		protected Dart.LiveControls.LiveLinkButton btnMessage3;
		protected Dart.LiveControls.LiveLinkButton btnMessage4;
		protected Dart.LiveControls.LiveLinkButton lnkCompose;
		protected Dart.LiveControls.LiveTextBox txtTo;
		protected Dart.LiveControls.LiveTextBox txtSubject;
		protected Dart.LiveControls.LiveTextBox txtMessage;
		protected Dart.LiveControls.LivePanel pnlCompose;
		protected Dart.LiveControls.LiveLinkButton btnSend;
		protected Dart.LiveControls.LiveMessageBox LiveMessageBox1;
		protected Dart.LiveControls.LiveDataGrid gridEmail;
		protected Dart.LiveControls.LiveImageButton btnContacts;
		protected Dart.LiveControls.LiveLabel lblFrom;
		protected Dart.LiveControls.LiveLabel lblDate;
		protected Dart.LiveControls.LiveLabel lblSubject;
		protected Dart.LiveControls.LiveLabel lblMessage;
		protected Dart.LiveControls.LivePanel pnlViewMail;
		protected Dart.LiveControls.LiveLinkButton btnClose;
		protected Dart.LiveControls.LiveLinkButton btnReply;
		protected Dart.LiveControls.LiveLinkButton btnForward;
		protected Dart.LiveControls.LiveDataGrid gridContacts;
		protected Dart.LiveControls.LiveLinkButton btnAddContact;

		private ArrayList contacts = new ArrayList();
		private ArrayList email = new ArrayList();
		private ArrayList pastDueActivities = new ArrayList();
		protected Dart.LiveControls.LiveDataGrid gridPastDue;
		protected Dart.LiveControls.LiveDataGrid gridDueToday;
		protected Dart.LiveControls.LiveLinkButton btnAddActivity;
		protected Dart.LiveControls.LiveLinkButton Livelinkbutton3;
		protected Dart.LiveControls.LivePanel pnlViewActivity;
		protected Dart.LiveControls.LiveLabel lblActivityDescription;
		protected Dart.LiveControls.LiveLabel lblPriority;
		protected Dart.LiveControls.LiveLabel lblType;
		protected Dart.LiveControls.LiveLabel lblDetail;
		protected Dart.LiveControls.LiveLabel lblDueDate;
		protected Dart.LiveControls.LiveLinkButton btnCloseActivity;
		protected Dart.LiveControls.LiveLinkButton btnMarkComplete;
		protected Dart.LiveControls.LiveRadioButton LiveRadioButton1;
		private ArrayList activities = new ArrayList();

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Next few functions are some cheating to provide some demo data
			LoadFakeMail();
			LoadFakeContacts();
			LoadFakePastDueActivities();
			LoadFakeActivities();
					
			// The reason these are done with each request is because the controls are dynamically created...and recreated
			// each request...so the bound properties are reinitialized.
			if(NewLoad || (!Page.IsPostBack))
			{
				UpdateUI(View.Activities);
				BindMailGrid();
				BindContactGrid();
				BindPastDueActivitiesGrid();
				BindActivitiesGrid();
				AddStyles();
				AddIconSizes();
				AddFontFaces();
			}
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnActivities.Click += new System.Web.UI.ImageClickEventHandler(this.btnActivities_Click);
			this.btnContacts.Click += new System.Web.UI.ImageClickEventHandler(this.btnContact_Click);
			this.btnEmail.Click += new System.Web.UI.ImageClickEventHandler(this.btnEmail_Click);
			this.btnStyles.Click += new System.Web.UI.ImageClickEventHandler(this.btnStyles_Click);
			this.gridPastDue.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.gridPastDue_ItemDataBound);
			this.gridPastDue.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.gridPastDue_ItemCommand);
			this.gridDueToday.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.gridDueToday_ItemDataBound);
			this.gridDueToday.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.gridDueToday_ItemCommand);
			this.btnAddActivity.Click += new System.EventHandler(this.btnAddActivity_Click);
			this.gridContacts.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.gridContacts_ItemDataBound);
			this.btnAddContact.Click += new System.EventHandler(this.btnAddContact_Click);
			this.gridEmail.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.gridEmail_ItemDataBound);
			this.gridEmail.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.gridEmail_ItemCommand);
			this.lnkCompose.Click += new System.EventHandler(this.lnkCompose_Click);
			this.ddStyles.SelectedIndexChanged += new System.EventHandler(this.ddStyles_SelectedIndexChanged);
			this.ddIconSize.SelectedIndexChanged += new System.EventHandler(this.ddIconSize_SelectedIndexChanged);
			this.ddFontFace.SelectedIndexChanged += new System.EventHandler(this.ddFontFace_SelectedIndexChanged);
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			this.btnReply.Click += new System.EventHandler(this.btnReply_Click);
			this.btnForward.Click += new System.EventHandler(this.btnForward_Click);
			this.btnCloseActivity.Click += new System.EventHandler(this.btnCloseActivity_Click);
			this.btnMarkComplete.Click += new System.EventHandler(this.btnMarkComplete_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnContact_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			UpdateUI(View.Contacts);
		}

		private void btnActivities_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			UpdateUI(View.Activities);
		}

		private void btnEmail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			UpdateUI(View.Email);
		}

		private void btnStyles_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			UpdateUI(View.Styles);
		}

		private void UpdateUI(View view)
		{
			switch(view)
			{
				case View.Contacts:
					SetPanels(pnlContacts);
					lblContactsTitle.Text = "<b>Contacts for " + System.DateTime.Now.ToShortDateString() + "</b>";
					break;
				case View.Activities:
					SetPanels(pnlActivities);
					lblActivitiesTitle.Text = "<b>Activities for " + System.DateTime.Now.ToShortDateString() + "</b>";
					break;
				case View.Email:
					SetPanels(pnlEmail);
					lblEmailTitle.Text = "<b>Email center</b>";
					break;
				case View.Styles:
					SetPanels(pnlStyles);
					lblStylesTitle.Text = "<b>Modify application style</b>";
					break;
			}
		}

		private void SetPanels(LivePanel panel)
		{
			bool val = false;
			val = (pnlContacts == panel?true:false);
			pnlContacts.Visible = val;
			val = (pnlActivities == panel?true:false);
			pnlActivities.Visible = val;
			val = (pnlEmail == panel?true:false);
			pnlEmail.Visible = val;
			val = (pnlStyles == panel?true:false);
			pnlStyles.Visible = val;
			
			pnlCompose.Visible = false;
			pnlViewMail.Visible = false;
			pnlViewActivity.Visible = false;
		}

		private void AddStyles()
		{
			ddStyles.Items.Add("Classic");
			ddStyles.Items.Add("Silver");
			ddStyles.Items.Add("Orange");
			ddStyles.Items.Add("Green");
		}

		private void AddIconSizes()
		{
			ddIconSize.Items.Add("Standard");
			ddIconSize.Items.Add("Large");
			ddIconSize.Items.Add("Small");
		}

		private void AddFontFaces()
		{
			ddFontFace.Items.Add("Default");
			ddFontFace.Items.Add("Impact");
			ddFontFace.Items.Add("Comic Sans MS");
			ddFontFace.Items.Add("Courier New");
			ddFontFace.Items.Add("Times New Roman");
		}

		private void LoadFakeMail()
		{
			// First add columns
			string date = System.DateTime.Now.ToShortDateString();
			email.Add(new Email("John Doe", date, "Meeting Tuesday", "Hey everyone,<br><br>The meeting Tuesday has been rescheduled for Wednesday. Let me know if there are any conflicts.<br><br>Thanks,<br>John"));
			email.Add(new Email("Bob Bobson", date, "Thanks!", "Thanks for the help in the bug fix. Our app went live yesterday and is doing well." ));
			email.Add(new Email("Jane Doe", date, "Hello", "Hello,<br><br>Did you know you can save up to 75% on prescription drugs? Go to http://www.myspammypharmacy.com."));
			email.Add(new Email("Rob Robson", date, "Would like to purchase", "Hello,<br>I would like to purchase your product. Can you process my order?"));
		}

		private void LoadFakeContacts()
		{
			contacts.Add(new Contact("Acme Corp", "John Doe", "222-555-1212", "12/1/2004"));
			contacts.Add(new Contact("Microsoft", "Bill Gates", "111-555-1234", "11/15/2004"));
			contacts.Add(new Contact("FakeCo Software", "Jane Doe", "333-555-9876", "10/18/2004"));
			contacts.Add(new Contact("Blah Soft", "Jim Blah", "222-555-3131", "12/7/2004"));
			contacts.Add(new Contact("Initech", "Michael Bolton", "444-444-4444", "1/5/2004"));
		}

		private void LoadFakePastDueActivities()
		{
			pastDueActivities.Add(new Activity("Run monthly reports", "Normal", "Task", "12/1/2004", "Need to run monthly sales reports for Bob."));
			pastDueActivities.Add(new Activity("Perform sales follow-ups", "High", "Phone", "12/5/2004", "Be sure to call back all sales from past week for follow-ups."));
			pastDueActivities.Add(new Activity("Fax leads to SoftTech", "Normal", "Fax", "12/6/2004", "Fax leads from yesterday to Doug at SoftTech."));
		}

		private void LoadFakeActivities()
		{
			string date = System.DateTime.Now.ToShortDateString();
			activities.Add(new Activity("Sales meeting", "High", "Task", date, "Meet with the sales team in the conference room at 3:00"));
			activities.Add(new Activity("Call John Doe", "Normal", "Phone", date, "Call John Doe RE purchase of product."));
			activities.Add(new Activity("Call Jim Blah", "Low", "Phone", date, "Call Jim Blah to set up lunch meeting during the conference in January"));
			activities.Add(new Activity("Send product info to Initech", "Normal", "Task", date, "Send product information to Michael at Initech"));
		}

		private void BindMailGrid()
		{
			gridEmail.DataSource = email;
			gridEmail.DataBind();
		}

		private void BindContactGrid()
		{
			gridContacts.DataSource = contacts;
			gridContacts.DataBind();
		}

		private void BindPastDueActivitiesGrid()
		{
			gridPastDue.DataSource = pastDueActivities;
			gridPastDue.DataBind();
		}

		private void BindActivitiesGrid()
		{
			gridDueToday.DataSource = activities;
			gridDueToday.DataBind();
		}

		private void ddStyles_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ddStyles.BufferedScript.Write("changeStyles('" + ddStyles.SelectedItem.Text + "');");
		}

		private void ddIconSize_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Unit u = Unit.Empty;
			if(ddIconSize.SelectedItem.Text == "Large")
				u = new Unit("50px");
			if(ddIconSize.SelectedItem.Text == "Small")
				u = new Unit("30px");
			btnActivities.Width = u;
			btnContacts.Width = u;
			btnEmail.Width = u;
			btnStyles.Width = u;
		}

		private void ddFontFace_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ddFontFace.BufferedScript.Write("changeFontFace('" + ddFontFace.SelectedItem.Text + "');");
		}

		private void lnkCompose_Click(object sender, System.EventArgs e)
		{
			pnlEmail.Visible = false;
			pnlCompose.Visible = true;
		}

		private void btnSend_Click(object sender, System.EventArgs e)
		{
			// Wait a bit to simulate mailing.
			System.Threading.Thread.Sleep(2000);

			// Display a messagebox
			string msg = "Message sent!\r\n\r\n";
			msg+= "...Well, not really. To simplify the application the email sending is simulated. ";
			msg+= "However, it would be simple to integrate this with PowerTCP Mail for .NET to make ";
			msg+= "this application able to send/receive email.";

			LiveMessageBox1.Show(msg, DialogType.Alert);
		}

		private void gridEmail_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item 
				|| e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Text = "<img src='images/openmail.gif' align='absmiddle'> " + e.Item.Cells[0].Text;

				LinkButton button = (LinkButton)e.Item.Cells[1].Controls[0];
				Email mail = (Email)email[e.Item.ItemIndex];
				button.Text = mail.Subject;
			}
		}


		private void btnClose_Click(object sender, System.EventArgs e)
		{
			pnlEmail.Visible = true;
			pnlViewMail.Visible = false;
		}

		private void btnReply_Click(object sender, System.EventArgs e)
		{
			LiveMessageBox1.Show("Sorry, the mail capability is stubbed out for demonstration purposes. You could easily make this work using PowerTCP Mail for .NET.", DialogType.Alert);

		}

		private void btnForward_Click(object sender, System.EventArgs e)
		{
			LiveMessageBox1.Show("Sorry, the mail capability is stubbed out for demonstration purposes. You could easily make this work using PowerTCP Mail for .NET.", DialogType.Alert);
		}

		private void gridContacts_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item 
				|| e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Text = "<img src='images/phone.gif' align='absmiddle'> " + e.Item.Cells[0].Text;
			}
		}

		private void btnAddContact_Click(object sender, System.EventArgs e)
		{
			LiveMessageBox1.Show("Sorry, the add contact capability is stubbed out for demonstration purposes. Try some of the other stuff in the demo application to see LiveControls in action.", DialogType.Alert);
		}

		private void gridDueToday_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item 
				|| e.Item.ItemType == ListItemType.AlternatingItem)
			{
				LinkButton button = (LinkButton)e.Item.Cells[0].Controls[0];
				Activity activity = (Activity)activities[e.Item.ItemIndex];
				button.Text = activity.Description;
				LiteralControl literal = new LiteralControl("&nbsp;<img src='images/" + e.Item.Cells[2].Text + ".gif' align='absmiddle'> " + e.Item.Cells[0].Text);
				e.Item.Cells[0].Controls.AddAt(0, literal);
			}
		}

		private void gridPastDue_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item 
				|| e.Item.ItemType == ListItemType.AlternatingItem)
			{
				LinkButton button = (LinkButton)e.Item.Cells[0].Controls[0];
				Activity activity = (Activity)pastDueActivities[e.Item.ItemIndex];
				button.Text = activity.Description;
				LiteralControl literal = new LiteralControl("&nbsp;<img src='images/" + e.Item.Cells[2].Text + ".gif' align='absmiddle'> " + e.Item.Cells[0].Text);
				e.Item.Cells[0].Controls.AddAt(0, literal);
			}
		}


		private void SetActivityFields(Activity activity)
		{
			lblActivityDescription.Text = activity.Description;
			lblDetail.Text = activity.Detail;
			lblPriority.Text = activity.Priority;
			lblType.Text = activity.Type;
			lblDueDate.Text = activity.DueDate;
		}

		private void btnAddActivity_Click(object sender, System.EventArgs e)
		{
			LiveMessageBox1.Show("Sorry, the add activity capability is stubbed out for demonstration purposes. Try some of the other stuff in the demo application to see LiveControls in action.", DialogType.Alert);
		}

		private void btnCloseActivity_Click(object sender, System.EventArgs e)
		{
			pnlActivities.Visible = true;
			pnlViewActivity.Visible = false;
		}

		private void btnMarkComplete_Click(object sender, System.EventArgs e)
		{
			LiveMessageBox1.Show("Sorry, the mark activity complete capability is stubbed out for demonstration purposes. Try some of the other stuff in the demo application to see LiveControls in action.", DialogType.Alert);
		}

		private void gridEmail_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			pnlEmail.Visible = false;
			pnlViewMail.Visible = true;
				
			Email mail = (Email)email[e.Item.ItemIndex];
			lblFrom.Text = mail.From;
			lblDate.Text = mail.Date;
			lblSubject.Text = mail.Subject;
			lblMessage.Text = mail.Message;
		}

		private void gridDueToday_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			pnlActivities.Visible = false;
			pnlViewActivity.Visible = true;

			SetActivityFields((Activity)activities[e.Item.ItemIndex]);
		}

		private void gridPastDue_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			pnlActivities.Visible = false;
			pnlViewActivity.Visible = true;

			SetActivityFields((Activity)pastDueActivities[e.Item.ItemIndex]);
		}
	}
}
