<%@ Control Language="c#" AutoEventWireup="false" Codebehind="b)_how_do_Live_Controls_work.ascx.cs" Inherits="LiveTutorial.b_how_do_LiveControls_work" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<%@ Register TagPrefix="cc1" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<p>
	As demonstrated in the first topic, LiveControls enable building of advanced 
	web applications which are much cleaner looking and more responsive than 
	standard web applications. This is possible by the technologies available in 
	LiveControls.</p>
<p>Most developers are familiar with the ASP.NET postback methodology:</p>
<ol>
	<li>
	User is presented with an interface.
	<li>
	User clicks an ASP.NET Button, causing a POSTBACK to the server.
	<li>
	HTTP POST is issued.
	<li>
	ASP.NET runtime scans the incoming POST request and raises the Button.Click 
	event.
	<li>
	Code executes within the Button.Click event, modifying something.
	<li>
	The entire page is resent to the browser.
	<li>
		Browser reloads and rerenders the page content, causing a "white flash".</li>
</ol>
<p>The drawbacks of this type of approach are obvious:
	<br>
	<ol>
		<li>
		Given a 10000 character HTML file, if 5 of the characters are changed, all 
		10000 characters have to be resent to the client. This inefficiency causes 
		longer load times and wastes network bandwidth.
		<li>
			When the browser re-displays the page, it "whites-out" and redraws the entire 
			page. This process can take anywhere from a fraction of a second to several 
			seconds.
		</li>
	</ol>
<P></P>
<p>For many web applications, the above limitations are acceptable. However, many 
	web applications require more advanced communication with the server. Live 
	Controls enables this type communication.</p>
<p>Compare the above page cycle to a Live Control page cycle:</p>
<ol>
	<li>
	User is presented with an interface.
	<li>
	User clicks a Live Button, causing a CALLBACK to the server.
	<li>
	A LiveControl POST is issued.
	<li>
	ASP.NET runtime raises the LiveButton.Click event.
	<li>
	Code executes within the LiveButton.Click event, modifying something.
	<li>
	A small bit of code is sent back to update the changed element only.
	<li>
		Code executes on the client and updates the interface smoothly without a 
		refresh.</li>
</ol>
<p>Click the button below to run a side by side comparison of a simple clock built 
	using LiveControls to the same clock built using standard controls. The 
	comparison uses a LiveTimer to constantly poll the server, updating the client 
	interface with the server's local time. Note how even in this simple example, 
	the standard control postback limitations below are quite noticeable.</p>
<input type="button" value="Side by side comparison" onclick="window.open('tutorials/1)_overview/clockdemo.aspx', '_blank', 'height=400,width=1020,resizable=yes,scrollbars=no,status=no,toolbar=no,top=200,left=500', true)">
<cc1:LiveTimer id="LiveTimer1" runat="server"></cc1:LiveTimer>
