namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for d_modifying_control_styles.
	/// </summary>
	public abstract class d_modifying_control_styles : LiveUserControl
	{
		protected Dart.LiveControls.LiveRadioButtonList lstBackColor;
		protected Dart.LiveControls.LiveRadioButtonList lstForeColor;
		protected Dart.LiveControls.LiveRadioButtonList lstBorderWidth;
		protected Dart.LiveControls.LiveRadioButtonList lstBorderColor;
		protected Dart.LiveControls.LiveRadioButtonList lstBorderStyle;
		protected Dart.LiveControls.LiveCheckBox chkBold;
		protected Dart.LiveControls.LiveCheckBox chkItalic;
		protected Dart.LiveControls.LiveCheckBox chkUnderline;
		protected Dart.LiveControls.LiveCheckBox chkStrikeout;
		protected Dart.LiveControls.LiveLabel LiveLabel1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(NewLoad)
				LoadLists();
			LiveLabel1.IsCallback = true;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lstBackColor.SelectedIndexChanged += new System.EventHandler(this.lstBackColor_SelectedIndexChanged);
			this.lstForeColor.SelectedIndexChanged += new System.EventHandler(this.lstForeColor_SelectedIndexChanged);
			this.chkBold.CheckedChanged += new System.EventHandler(this.chkBold_CheckedChanged);
			this.chkItalic.CheckedChanged += new System.EventHandler(this.chkItalic_CheckedChanged);
			this.chkUnderline.CheckedChanged += new System.EventHandler(this.chkUnderline_CheckedChanged);
			this.chkStrikeout.CheckedChanged += new System.EventHandler(this.chkStrikeout_CheckedChanged);
			this.lstBorderWidth.SelectedIndexChanged += new System.EventHandler(this.lstBorderWidth_SelectedIndexChanged);
			this.lstBorderStyle.SelectedIndexChanged += new System.EventHandler(this.lstBorderStyle_SelectedIndexChanged);
			this.lstBorderColor.SelectedIndexChanged += new System.EventHandler(this.lstBorderColor_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LoadLists()
		{
			lstBackColor.Items.Add("White");
			lstBackColor.Items.Add("Red");
			lstBackColor.Items.Add("Blue");
			lstBackColor.Items.Add("Yellow");
			lstBackColor.SelectedIndex = 0;

			lstForeColor.Items.Add("Black");
			lstForeColor.Items.Add("White");
			lstForeColor.Items.Add("Gray");
			lstForeColor.Items.Add("Orange");
			lstForeColor.SelectedIndex = 0;
		
			lstBorderStyle.Items.Add("None");
			lstBorderStyle.Items.Add("Solid");
			lstBorderStyle.Items.Add("Dotted");
			lstBorderStyle.Items.Add("Dashed");
			lstBorderStyle.SelectedIndex = 1;
				
			lstBorderWidth.Items.Add("1px");
			lstBorderWidth.Items.Add("2px");
			lstBorderWidth.Items.Add("3px");
			lstBorderWidth.Items.Add("4px");
			lstBorderWidth.SelectedIndex = 0;

			lstBorderColor.Items.Add("Black");
			lstBorderColor.Items.Add("Pink");
			lstBorderColor.Items.Add("LightGreen");
			lstBorderColor.Items.Add("LightBlue");
			lstBorderColor.SelectedIndex = 0;
		}

		private void lstBackColor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LiveLabel1.BackColor = ColorTranslator.FromHtml(lstBackColor.SelectedItem.Value);
		}

		private void lstForeColor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LiveLabel1.ForeColor = ColorTranslator.FromHtml(lstForeColor.SelectedItem.Value);
		}

		private void lstBorderWidth_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LiveLabel1.BorderWidth = new Unit(lstBorderWidth.SelectedItem.Value);	
		}

		private void lstBorderStyle_SelectedIndexChanged(object sender, System.EventArgs e)
		{	
			LiveLabel1.BorderStyle = (BorderStyle)Enum.Parse(typeof(BorderStyle), lstBorderStyle.SelectedItem.Value, true);
		}

		private void lstBorderColor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LiveLabel1.BorderColor = ColorTranslator.FromHtml(lstBorderColor.SelectedItem.Value);
		}

		private void chkBold_CheckedChanged(object sender, System.EventArgs e)
		{
			doCheckBoxBlock();
		}

		private void chkItalic_CheckedChanged(object sender, System.EventArgs e)
		{
			doCheckBoxBlock();
		}

		private void chkUnderline_CheckedChanged(object sender, System.EventArgs e)
		{
			doCheckBoxBlock();
		}

		private void chkStrikeout_CheckedChanged(object sender, System.EventArgs e)
		{
			doCheckBoxBlock();
		}

		private void doCheckBoxBlock()
		{
			LiveLabel1.Font.Bold = chkBold.Checked;
			LiveLabel1.Font.Italic = chkItalic.Checked;
			LiveLabel1.Font.Underline = chkUnderline.Checked;
			LiveLabel1.Font.Strikeout = chkStrikeout.Checked;
		}
	}
}
