namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.OleDb;

	/// <summary>
	///		Summary description for c_using_the_LiveDataGrid.
	/// </summary>
	public abstract class c_using_the_LiveDataGrid : LiveUserControl
	{
		protected Dart.LiveControls.LiveDataGrid LiveDataGrid1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(NewLoad)
			{
				CurSortExpression = "none";
				CurSortDirection = "none";
				try
				{
					DoBind("", "");
				}
				catch(Exception ex)
				{
					Session["DataBaseError"] = ex.ToString();
					Response.Redirect("DataBaseError.aspx");
				}
			}
		}

		public string CurSortExpression
		{
			get
			{
				object o = Session["CurSortExpression"];
				return(o==null)?"ProductID":(string)o;
			}
			set
			{
				Session["CurSortExpression"] = value;
			}
		}

		public string CurSortDirection
		{
			get
			{
				object o = Session["CurSortDirection"];
				return(o==null)?"asc":(string)o;
			}
			set
			{
				Session["CurSortDirection"] = value;
			}
		}

		private string GetConnectionString()
		{
			if(!System.IO.File.Exists((string)Session["DataBasePath"]))
				throw new Exception("Unable to locate database");
			return "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" + (string)Session["DataBasePath"];
		}

		private void DoBind(string sortField, string sortDirection)
		{
			OleDbConnection connection = new OleDbConnection(GetConnectionString());
			string sql = "SELECT * FROM Products";
			if(sortField != "")
				sql+= " ORDER BY " + sortField;
			if(sortField != "" && sortDirection != "")
				sql+= " " + sortDirection;
			OleDbDataAdapter adapter = new OleDbDataAdapter(sql, connection);

			DataSet dataSet = new DataSet("DataSetProducts");
			adapter.Fill(dataSet, "Products");
			
			DataView view = dataSet.Tables["Products"].DefaultView;
			LiveDataGrid1.DataSource = view;
			LiveDataGrid1.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.LiveDataGrid1.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.LiveDataGrid1_PageIndexChanged);
			this.LiveDataGrid1.SortCommand += new System.Web.UI.WebControls.DataGridSortCommandEventHandler(this.LiveDataGrid1_SortCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LiveDataGrid1_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			try
			{
				LiveDataGrid1.CurrentPageIndex = e.NewPageIndex;
				DoBind("", "");
			}
			catch(Exception ex)
			{
				Session["DataBaseError"] = ex.ToString();
				LiveDataGrid1.BufferedScript.Write("window.location = 'DataBaseError.aspx';");
				return;
			}
		}

		private void LiveDataGrid1_SortCommand(object source, System.Web.UI.WebControls.DataGridSortCommandEventArgs e)
		{
			if(CurSortExpression == "none")
				CurSortExpression = e.SortExpression;
			if(e.SortExpression == CurSortExpression)
			{
				if(CurSortDirection == "asc") 
					CurSortDirection = "desc";
				else
					CurSortDirection = "asc";
			}	
			else
			{
				CurSortExpression = e.SortExpression;
				CurSortDirection = "asc";
			}

			try
			{
				DoBind(CurSortExpression, CurSortDirection);
			}
			catch(Exception ex)
			{
				Session["DataBaseError"] = ex.ToString();
				LiveDataGrid1.BufferedScript.Write("window.location = 'DataBaseError.aspx';");
				return;
			}
		}
	}
}
