namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Reflection;

	/// <summary>
	///		Summary description for f_using_live_list_controls.
	/// </summary>
	public abstract class f_using_live_list_controls : LiveUserControl
	{
		protected Dart.LiveControls.LiveListBox Livelistbox1;
		protected Dart.LiveControls.LiveListBox Livelistbox2;
		protected Dart.LiveControls.LiveListBox Livelistbox3;
		protected Dart.LiveControls.LiveListBox Livelistbox4;
		protected Dart.LiveControls.LiveLabel LiveLabel1;


		private Assembly _Assembly = null;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_Assembly = Livelistbox1.GetType().Assembly;

			if(!LiveLabel1.IsCallback)
				LoadInitialListBox();
		}


		private void LoadInitialListBox()
		{
			Livelistbox1.Items.Clear();
			Type[] types = _Assembly.GetTypes();	
			foreach(Type type in types)
			{
				if(!type.IsSubclassOf(typeof(System.Windows.Forms.Form))
					&& !type.IsInterface
					&& type.IsPublic
					&& type.IsClass
					&& type.Namespace == "Dart.LiveControls")
					Livelistbox1.Items.Add(type.Name);
			}
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Livelistbox1.SelectedIndexChanged += new System.EventHandler(this.Livelistbox1_SelectedIndexChanged);
			this.Livelistbox2.SelectedIndexChanged += new System.EventHandler(this.Livelistbox2_SelectedIndexChanged);
			this.Livelistbox3.SelectedIndexChanged += new System.EventHandler(this.Livelistbox3_SelectedIndexChanged);
			this.Livelistbox4.SelectedIndexChanged += new System.EventHandler(this.Livelistbox4_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Livelistbox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(Livelistbox1.SelectedIndex == -1) return;
			LiveLabel1.Text = "";
			Livelistbox2.Items.Clear();
			Livelistbox3.Items.Clear();
			Livelistbox4.Items.Clear();

			string className = Livelistbox1.SelectedItem.Text;
			Type type = _Assembly.GetType("Dart.LiveControls." + className);
			CurrentType = type;
			foreach(PropertyInfo propertyInfo in type.GetProperties())
				Livelistbox2.Items.Add(propertyInfo.Name);
			foreach(MethodInfo methodInfo in type.GetMethods())
			{
				if(methodInfo.Name.IndexOf("get_") == -1 
					&& methodInfo.Name.IndexOf("set_") == -1
					&& methodInfo.Name.IndexOf("add_") == -1
					&& methodInfo.Name.IndexOf("remove_") == -1)
					Livelistbox3.Items.Add(methodInfo.Name);
			}
			foreach(EventInfo eventInfo in type.GetEvents())
				Livelistbox4.Items.Add(eventInfo.Name);
		}

		private void Livelistbox2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(Livelistbox2.SelectedIndex == -1) return;
			if(CurrentType == null) return;
			PropertyInfo propertyInfo = CurrentType.GetProperty(Livelistbox2.SelectedItem.Text);
			
			string val = "<b>Property description:</b><br>";
			val+= "public" + GetModifier(propertyInfo.GetGetMethod()) + " " +  propertyInfo.PropertyType.Name + " " + propertyInfo.Name;
			val+= "{";
			if(propertyInfo.CanRead) val += "get;";
			if(propertyInfo.CanWrite) val += " set;";
			val+= "}";
			LiveLabel1.Text = val;
		}

		private string GetModifier(MethodInfo methodInfo)
		{
			if(methodInfo.IsAbstract)
				return " abstract";
			if(methodInfo.IsStatic)
				return " static";
			if(methodInfo.IsVirtual)
				return " virtual";
			return "";
		}

		private void Livelistbox3_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(Livelistbox3.SelectedIndex == -1) return;
			if(CurrentType == null) return;
			MethodInfo methodInfo = CurrentType.GetMethod(Livelistbox3.SelectedItem.Text);
			string val = "<b>Method description:</b><br>";
			val+= "public" + GetModifier(methodInfo) + " " + methodInfo.ReturnType.Name + " " + methodInfo.Name;
			val+= "(";
			foreach(ParameterInfo param in methodInfo.GetParameters())
			{
				val+= param.ParameterType.Name  + " " + param.Name + ", ";
			}
			if(val.EndsWith(", ")) val = val.Substring(0, val.Length-2);
			val+= ")";
			LiveLabel1.Text = val;
		}

		private void Livelistbox4_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(Livelistbox4.SelectedIndex == -1) return;
			if(CurrentType == null) return;
			EventInfo eventInfo = CurrentType.GetEvent(Livelistbox4.SelectedItem.Text);
			string val = "<b>Event description:</b><br>";
			val+= "public event " + eventInfo.EventHandlerType.Name + " " + eventInfo.Name;
			LiveLabel1.Text = val;
		}

		public Type CurrentType
		{
			get
			{
				object o = Session["CurrentType"];
				return(o==null)?null:(Type)o;
			}
			set
			{
				Session["CurrentType"] = value;
			}
		}
	}
}
