namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using Dart.LiveControls;

	/// <summary>
	///		Summary description for f_using_LiveSound.
	/// </summary>
	public abstract class f_using_LiveSound : LiveUserControl
	{
		protected Dart.LiveControls.LiveLabel lblMachine1;
		protected Dart.LiveControls.LiveLabel lblMachine3;
		protected Dart.LiveControls.LiveLabel lblMachine4;
		protected Dart.LiveControls.LiveButton btnStart;
		protected Dart.LiveControls.LiveButton btnStop;
		protected Dart.LiveControls.LiveSound LiveSound1;
		protected Dart.LiveControls.LiveTimer LiveTimer1;
		protected Dart.LiveControls.LiveMessageBox LiveMessageBox1;
		protected Dart.LiveControls.LiveButton btnReset;
		protected Dart.LiveControls.LiveLabel lblMachine2;

		
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(NewLoad)
			{
				//LiveTimer1.Interval = 500;
				lblMachine1.Text = lblMachine2.Text = lblMachine3.Text = lblMachine4.Text = "";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			this.LiveTimer1.Tick += new System.EventHandler(this.LiveTimer1_Tick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			LiveTimer1.Start();
		}

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			LiveTimer1.Stop();
		}

		public ArrayList MaxTemps
		{
			get
			{
				object o = Session["MaxTemps"];
				if(o == null)
				{
					o = CreateMaxTemps();
					Session["MaxTemps"] = o;
				}
				return (ArrayList)o;
			}
			set
			{
				Session["MaxTemps"] = value;
			}
		}

		public ArrayList CurTemps
		{
			get
			{
				object o = Session["CurTemps"];
				if(o == null)
				{
					o = CreateInitialTemps();
					Session["CurTemps"] = o;
				}
				return (ArrayList)o;
			}
			set
			{
				Session["CurTemps"] = value;
			}
		}

		private ArrayList CreateInitialTemps()
		{
			ArrayList temps = new ArrayList();
			temps.Add(500);
			temps.Add(400);
			temps.Add(300);
			temps.Add(600);
			return temps;
		}

		private ArrayList CreateMaxTemps()
		{
			ArrayList temps = new ArrayList();
			temps.Add(530);
			temps.Add(500);
			temps.Add(400);
			temps.Add(800);
			return temps;

		}

		private void LiveTimer1_Tick(object sender, System.EventArgs e)
		{
			if (LiveTimer1.Enabled)
			{
				SetNewTemps();
				UpdateInterface();
				CheckForDanger();
			}
		}

		private void SetNewTemps()
		{
			// "fake" modification of the current temps...need to make sure at least one 
			// always goes up...so the user will not have to wait forever for the sound to go off
			
			// get the sign first
			
			int sign = ((Randomize(0, 2) == 0)?-1:1);

			// now get the modifiers
			int mod1 = Randomize(0, 11);
			int mod2 = Randomize(0, 11);
			int mod3 = Randomize(0, 11);
			int mod4 = Randomize(0, 11);

			// Add the sign and the modifier to machine 1, 2, and 4....these will fluctuate.
			int val = (int)CurTemps[0];
			CurTemps[0] = val + (sign * mod1);
			val = (int)CurTemps[1];	
			CurTemps[1] = val + (sign * mod2);
			val = (int)CurTemps[3];	
			CurTemps[3] = val + (sign * mod4);

			// Machine 3 will get the modifier only...SOMETHING IS WRONG WITH THIS MACHINE!!!!!!!
			val = (int)CurTemps[2];
			CurTemps[2] = val + mod3;
		}

		private int Randomize(int min, int max)
		{
			System.Threading.Thread.Sleep(5);
			Random rand = new Random();
			return rand.Next(min, max);
		}

		private void UpdateInterface()
		{
			lblMachine1.Text = CurTemps[0] + " degrees";
			lblMachine2.Text = CurTemps[1] + " degrees";
			lblMachine3.Text = CurTemps[2] + " degrees";
			lblMachine4.Text = CurTemps[3] + " degrees";
		}

		private void CheckForDanger()
		{
			for(int i=0; i<CurTemps.Count; i++)
			{
				int cur = (int)CurTemps[i];
				int max = (int)MaxTemps[i];
				if(cur > max)
				{
					// DANGER...notify someone
					if(i == 0)TakeDangerAction(lblMachine1);
					if(i == 1)TakeDangerAction(lblMachine2);
					if(i == 2)TakeDangerAction(lblMachine3);
					if(i == 3)TakeDangerAction(lblMachine4);
				}
			}
		}

		private void TakeDangerAction(Dart.LiveControls.LiveLabel label)
		{
			bool alreadyAlerted = label.BackColor == Color.Red;
			label.BackColor = Color.Red;
			label.Text = label.Text + " OVERHEATED! CHECK NOW!";
			label.Font.Bold = true;
			label.ForeColor = Color.White;
			if(alreadyAlerted) return;
			LiveSound1.Play();
		}

		private void btnReset_Click(object sender, System.EventArgs e)
		{
			LiveTimer1.Stop();
			CurTemps = CreateInitialTemps();
			resetLabel(lblMachine1);
			resetLabel(lblMachine2);
			resetLabel(lblMachine3);
			resetLabel(lblMachine4);
		}

		private void resetLabel(LiveLabel label)
		{
			label.BackColor = Color.Empty;
			label.ForeColor = Color.Empty;
			label.Font.Bold = false;
			label.Text = "";
		}
	}
}
