namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for a_interacting_with_microsoft_controls.
	/// </summary>
	public abstract class a_interacting_with_microsoft_controls : LiveUserControl
	{
		protected System.Web.UI.WebControls.Calendar Calendar1;
		protected Dart.LiveControls.LiveButton LiveButton2;
		protected Dart.LiveControls.LiveButton LiveButton1;


		private int seed = -1;
		private string[] fonts = {"Impact", "Courier", "Arial", "Tahoma", "Terminal", "Comic Sans MS"};

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			seed = new Random().Next(0, 1000);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.LiveButton1.Click += new System.EventHandler(this.LiveButton1_Click);
			this.LiveButton2.Click += new System.EventHandler(this.LiveButton2_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LiveButton1_Click(object sender, System.EventArgs e)
		{
			int month = Randomize(1, 12);
			int year = Randomize(1, 2000);
			int day = Randomize(1, DateTime.DaysInMonth(year, month));
			Calendar1.VisibleDate = Calendar1.SelectedDate = new DateTime(year, month, day);
		}

		private int Randomize(int min, int max)
		{
			return new Random(seed+=5).Next(min, max);
		}

		private void LiveButton2_Click(object sender, System.EventArgs e)
		{
			ApplyRandomStyle(Calendar1.ControlStyle);
			ApplyRandomStyle(Calendar1.DayHeaderStyle);
			ApplyRandomStyle(Calendar1.NextPrevStyle);
			ApplyRandomStyle(Calendar1.OtherMonthDayStyle);
			ApplyRandomStyle(Calendar1.SelectedDayStyle);
			ApplyRandomStyle(Calendar1.SelectorStyle);
			ApplyRandomStyle(Calendar1.TitleStyle);
			ApplyRandomStyle(Calendar1.WeekendDayStyle);
		}

		private void ApplyRandomStyle(Style style)
		{
			style.BackColor = GetRandomColor();
			style.BorderColor = GetRandomColor();
			style.ForeColor = GetRandomColor();	
			style.Font.Name = fonts[Randomize(0, 5)];
			style.Font.Bold = Convert.ToBoolean(Randomize(0,1));
			style.Font.Italic = Convert.ToBoolean(Randomize(0,1));
			style.Font.Underline = Convert.ToBoolean(Randomize(0,1));
			style.Font.Size = new FontUnit(Randomize(8, 16));
		}

		private Color GetRandomColor()
		{
			string r = GetHexValue();
			string g = GetHexValue();
			string b = GetHexValue();
			return System.Drawing.ColorTranslator.FromHtml("#" + r + g + b);
		}

		private string GetHexValue()
		{
			string val = Convert.ToString(Randomize(0, 256), 16);
			return (val.Length==2)?val:"0" + val;
		}
	}
}
