namespace LiveTutorial
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		Summary description for b_interacting_with_3rd_party_controls.
	/// </summary>
	public abstract class b_interacting_with_3rd_party_controls : LiveUserControl
	{
		protected Dart.LiveControls.LiveTextBox txtText;
		protected Dart.LiveControls.LiveDropDownList ddTextColor;
		protected Dart.LiveControls.LiveDropDownList ddFontName;
		protected Dart.LiveControls.LiveDropDownList ddGradientColor1;
		protected Dart.LiveControls.LiveDropDownList ddGradientColor2;
		protected MSPress.ServerComponents.ImageLabel ImageLabel1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(NewLoad)
			{
				// Put user code to initialize the page here
				ImageLabel1.Width = new Unit("400px");
				ImageLabel1.Height = new Unit("200px");
				ImageLabel1.BackColor = Color.White;
				ImageLabel1.BackColor2 = Color.White;
				ImageLabel1.Text = "Test Image";
			
				// Load drop down values 
				ArrayList colors = GetColors();
				ddGradientColor1.DataSource = colors;
				ddGradientColor1.DataBind();
				ddGradientColor2.DataSource = colors;
				ddGradientColor2.DataBind();
				ddTextColor.DataSource = colors;
				ddTextColor.DataBind();
				ddTextColor.SelectedIndex = 1;
				ddFontName.DataSource = GetFontNames();
				ddFontName.DataBind();
			}		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtText.TextChanged += new System.EventHandler(this.txtText_TextChanged);
			this.ddTextColor.SelectedIndexChanged += new System.EventHandler(this.ddTextColor_SelectedIndexChanged);
			this.ddFontName.SelectedIndexChanged += new System.EventHandler(this.ddFontName_SelectedIndexChanged);
			this.ddGradientColor1.SelectedIndexChanged += new System.EventHandler(this.ddGradientColor1_SelectedIndexChanged);
			this.ddGradientColor2.SelectedIndexChanged += new System.EventHandler(this.ddGradientColor2_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		private ArrayList GetFontNames()
		{
			ArrayList names = new ArrayList();
			names.Add("Serif");
			names.Add("Impact");
			names.Add("Courier");
			names.Add("Arial");
			names.Add("Tahoma");
			names.Add("Terminal");
			names.Add("Comic Sans MS");
			return names;
		}

		private ArrayList GetColors()
		{
			ArrayList colors = new ArrayList();
			colors.Add("White");
			colors.Add("Black");
			colors.Add("Aqua");
			colors.Add("Blue");
			colors.Add("Fuchsia");
			colors.Add("Gray");
			colors.Add("Green");
			colors.Add("Lime");
			colors.Add("Maroon");
			colors.Add("Navy");
			colors.Add("Olive");
			colors.Add("Purple");
			colors.Add("Red");
			colors.Add("Silver");
			colors.Add("Teal");
			colors.Add("Yellow");
			return colors;
		}

		private void txtText_TextChanged(object sender, System.EventArgs e)
		{
			UpdateImage();
		}

		private void ddTextColor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateImage();
		}

		private void ddFontName_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateImage();
		}

		private void ddGradientColor1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateImage();
		}

		private void ddGradientColor2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			UpdateImage();
		}

		private void UpdateImage()
		{
			ImageLabel1.Text = txtText.Text;
			ImageLabel1.ForeColor = System.Drawing.ColorTranslator.FromHtml(ddTextColor.SelectedItem.Text);
			ImageLabel1.Font.Name = ddFontName.SelectedItem.Value;
			ImageLabel1.BackColor = System.Drawing.ColorTranslator.FromHtml(ddGradientColor1.SelectedItem.Text);
			ImageLabel1.BackColor2 = System.Drawing.ColorTranslator.FromHtml(ddGradientColor2.SelectedItem.Text);
		}
	}
}
