Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.IO
Imports Dart.LiveControls

Namespace LiveTutorial
	''' <summary>
	''' Summary description for WebForm1.
	''' </summary>
	Public Class _default
		Inherits System.Web.UI.Page

		Protected plcContent As Dart.LiveControls.LivePlaceHolder
		Protected WithEvents lnkViewSource As Dart.LiveControls.LiveLinkButton
		Protected lblCode As Dart.LiveControls.LiveTextBox
		Protected WithEvents lnkViewServerTags As Dart.LiveControls.LiveLinkButton
		Protected lblViewServerTags As Dart.LiveControls.LiveTextBox
		Protected lblHeading As Dart.LiveControls.LiveLabel
		Protected CallbackTester As Dart.LiveControls.LiveSound
		Protected PlaceHolder1 As System.Web.UI.WebControls.PlaceHolder
		Protected LiveSound1 As Dart.LiveControls.LiveSound
		Protected lblControlsUsed As Dart.LiveControls.LiveLabel

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			If Not Me.DesignMode Then
				InitializeComponent()
			End If
			MyBase.OnInit(e)
		End Sub

		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.lnkViewServerTags.Command += New System.Web.UI.WebControls.CommandEventHandler(Me.lnkViewServerTags_Command)
'			Me.lnkViewSource.Command += New System.Web.UI.WebControls.CommandEventHandler(Me.lnkViewSource_Command)
'			Me.Load += New System.EventHandler(Me.Page_Load)
'			Me.Init += New System.EventHandler(Me._default_Init)
'			Me.PreRender += New System.EventHandler(Me._default_PreRender)

		End Sub
		#End Region

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			If Not Page.IsPostBack Then
				Session("DataBaseError") = ""
				Session("DataBasePath") = Server.MapPath("data/northwind.mdb")
				Session("DataBaseCommand") = Nothing
			End If
			'Page.Request.SaveAs("C:\\temp\\post.txt", true);
		End Sub

		Private Sub LoadMenu()
			Dim path As String = Server.MapPath("")
			path &= "\tutorials"

			Dim directories() As String = Directory.GetDirectories(path)

			For Each directory As String In directories
				GetMenuItems(directory)
			Next directory
		End Sub

		Public Function GetMenuItems(ByVal dir As String) As String
			Dim dirName As String = (New DirectoryInfo(dir)).Name
			Dim label As New LiveLabel()
			If plcContent.BrowserType = BrowserType.Mozilla Then
				label.Text = "<br><br><p><b>" & CapsFirstLetters(dirName) & "</b>"
			Else
				label.Text = "<p><b>" & CapsFirstLetters(dirName) & "</b>"
			End If
			PlaceHolder1.Controls.Add(label)

			Dim files() As String = Directory.GetFiles(dir)
'INSTANT VB NOTE: The variable items was renamed since Visual Basic does not handle local variables named the same as class members well:
			Dim items_Renamed As String = ""

			For Each file As String In files
				Dim fileInfo As New FileInfo(file)
				If fileInfo.Extension = ".ascx" Then
					PlaceHolder1.Controls.Add(New LiteralControl("<br>&nbsp&nbsp&nbsp"))
					Dim link As New LiveLinkButton()
					Dim text As String = CapsFirstLetters(fileInfo.Name.Replace(fileInfo.Extension, ""))
					text = text.Split(")"c)(1).Substring(1, text.Split(")"c)(1).Length - 1)
					If text.StartsWith("What Are") OrElse text.StartsWith("How Do") Then
						text &= "?"
					End If
					link.Text = text
					link.CommandName = QuickEncode(text)
					link.CommandArgument = QuickEncode(dirName) & "/" & fileInfo.Name
					If CStr(Session("UserControl")) <> link.CommandArgument Then
						AddHandler link.Command, AddressOf menu_Command
					End If
					PlaceHolder1.Controls.Add(link)
				End If
			Next file
			Return items_Renamed
		End Function


		Private Sub menu_Command(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
			LoadUserControl(QuickDecode(CStr(e.CommandArgument)))
			SetHeading(QuickDecode(e.CommandName))
		End Sub

		Private Sub SetHeading(ByVal heading As String)
			Session("Heading") = heading
			lblHeading.Text = "<h4 class='heading'>" & heading & "</h5>"
		End Sub

		Private Function CapsFirstLetters(ByVal str As String) As String
			If str = "" OrElse str Is Nothing Then
				Return str
			End If
			Dim strParts() As String = str.Split("_"c)
			Dim newParts(strParts.Length - 1) As String
			For i As Integer = 0 To strParts.Length - 1
				Dim strPart As String = strParts(i)
				If Not strPart.EndsWith(")") Then
					newParts(i) = strPart.ToUpper().Substring(0, 1) & strPart.Substring(1, strPart.Length - 1)
				Else
					newParts(i) = strPart
				End If
			Next i
			str = ""
			For Each newPart As String In newParts
				str &= newPart & " "
			Next newPart
			Return str.Substring(0, str.Length -1)
		End Function

		Private Sub LoadUserControl(ByVal controlPath As String)
			Dim newLoad As Boolean = False
			Session("PrevControl") = Session("UserControl")
			Session("UserControl") = controlPath
			plcContent.Controls.Clear()
			Try
				Dim controlFullPath As String = "tutorials/" & controlPath
				Dim control As UserControl = CType(Me.LoadControl(controlFullPath), UserControl)
				If Session("UserControl") IsNot Nothing AndAlso Session("PrevControl") IsNot Nothing Then
					If CStr(Session("UserControl")) <> CStr(Session("PrevControl")) Then
						newLoad = True
					End If
				Else
					newLoad = True
				End If
				If TypeOf control Is LiveUserControl Then
					CType(control, LiveUserControl).NewLoad = newLoad
				End If

				If newLoad AndAlso Page.IsPostBack Then
					ShowCode(Nothing, lnkViewSource, lblCode, "View Code-Behind Source")
					ShowCode(Nothing, lnkViewServerTags, lblViewServerTags, "View ASPX Source")
				End If

				'control.ID = "LiveUserControl";
				control.ID = controlPath
				SetServerControlsUsed(CType(control, LiveUserControl))
				plcContent.Controls.Add(control)
				plcContent.IsLive = newLoad
				lnkViewServerTags.Visible = True
				lnkViewSource.Visible = lnkViewServerTags.Visible
				lnkViewServerTags.CommandName = "LoadControl"
				lnkViewSource.CommandName = lnkViewServerTags.CommandName
				lnkViewServerTags.CommandArgument = controlFullPath
				lnkViewSource.CommandArgument = controlFullPath & ".cs"
			Catch ex As Exception
				Dim errorLabel As New Label()
				errorLabel.Text = "Unable to load page content. Error reported by server:<br><br>" & ex.ToString()
				plcContent.Controls.Add(errorLabel)
				lnkViewServerTags.Visible = False
				lnkViewSource.Visible = lnkViewServerTags.Visible
				lnkViewServerTags.CommandName = ""
				lnkViewSource.CommandName = lnkViewServerTags.CommandName
				lnkViewSource.CommandArgument = ""
				lblControlsUsed.Text = ""
			End Try
		End Sub

		Public Sub SetServerControlsUsed(ByVal control As LiveUserControl)
			Dim usedControls As New ArrayList()
			Dim liveControls As ArrayList = control.GetLiveControls()
			For Each liveControl As ILiveControl In liveControls
				Dim found As Boolean = False
				For Each str As String In usedControls
					If str = CType(liveControl, Object).GetType().Name Then
						found = True
					End If
				Next str
				If Not found Then
					usedControls.Add(CType(liveControl, Object).GetType().Name)
				End If
			Next liveControl

			usedControls.Sort()
			Dim list As String = "<ul>"
			For Each str As String In usedControls
				list &= "<li>" & str
			Next str
			list &= "</ul>"
			lblControlsUsed.Text = ""
			lblControlsUsed.Text = list
		End Sub


		Private Sub lnkViewSource_Command(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs) Handles lnkViewSource.Command
			ShowCode(e, CType(sender, LiveLinkButton), lblCode, "View Code-Behind Source")
		End Sub

		Private Sub lnkViewServerTags_Command(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs) Handles lnkViewServerTags.Command
			ShowCode(e, CType(sender, LiveLinkButton), lblViewServerTags, "View ASPX Source")
		End Sub

		Private Sub ShowCode(ByVal e As CommandEventArgs, ByVal button As LiveLinkButton, ByVal label As LiveTextBox, ByVal txt As String)
			If e IsNot Nothing Then
				If e.CommandName <> "LoadControl" Then
					Return
				End If
			End If
			If label.Visible OrElse e Is Nothing Then
				button.Text = "<img src=images/expand.gif align=absmiddle border=0> <b>" & txt & ":</b>"
				label.Visible = False
				label.Text = ""
			Else
				button.Text = "<img src=images/contract.gif align=absmiddle border=0> <b>" & txt & ":</b>"
				label.Visible = True
				Dim path As String = Server.MapPath("")
				path &= "\" & e.CommandArgument.ToString()
				label.Text = GetFileText(path)
			End If
		End Sub

		Private Function GetFileText(ByVal path As String) As String
			Try
				Dim fStream As New FileStream(path, FileMode.Open, FileAccess.Read)
				Dim reader As New StreamReader(fStream)
				Dim text As String = reader.ReadToEnd()
				fStream.Close()
				' Return straight text found in file. 
				Return text
			Catch
				Dim fil As New FileInfo(path)
				Return "Unable to access source code. Please be sure the ASPNET account has proper access rights to the file " & fil.FullName & ". To avoid seeing this error again while using this application, you may want to set access rights on the entire directory at " & fil.Directory.Parent.FullName & "."
			End Try
		End Function


		Private Function QuickEncode(ByVal text As String) As String
			Return text.Replace(" ", "%20")
		End Function

		Private Function QuickDecode(ByVal text As String) As String
			Return text.Replace("%20", " ")
		End Function

		Private Sub _default_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init
			LoadMenu()
			If Not Page.IsPostBack Then
				LoadUserControl("1)_overview/a)_what_are_live_controls.ascx")
				SetHeading("What Are Live Controls?")
			Else
				' Reload stuff from session
				LoadUserControl(CStr(Session("UserControl")))
				SetHeading(CStr(Session("Heading")))
			End If
		End Sub

		Protected Overrides Function LoadPageStateFromPersistenceMedium() As Object
			Dim state As Object = Me.Session("DisplayState")
			Return state
		End Function

		Protected Overrides Sub SavePageStateToPersistenceMedium(ByVal viewState As Object)
			Me.Session.Add("DisplayState", viewState)
		End Sub

		Private Sub _default_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
			If Session("UserControl") Is Session("PrevControl") Then
				plcContent.IsLive = False
			Else
				plcContent.IsLive = True
			End If
		End Sub
	End Class
End Namespace
