<%@ Register TagPrefix="cc1" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="b)_different_ways_to_initiate_callbacks.ascx.vb" Inherits="LiveTutorial.different_ways_to_initiate_callbacks" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<p>The key when using a LiveControl is to generate a callback. Once a callback has 
	been generated, a server-side event will be raised corresponding to the control 
	that initiated the callback (such as LiveButton.Click, LiveTextBox.TextChanged, 
	or LiveDropDownList.SelectedIndexChanged). Within this event ANY server control 
	(including LiveControls, Microsoft ASP.NET controls, and 3rd party controls) 
	can be updated visually...simply by setting the properties of the control (See 
	"Interacting With Non-Live Controls" in this tutorial for more info).</p>
<p>Any LiveControl is capable of initiating a callback (with the exception of 
	LivePlaceHolder and LiveSound. These are special purpose controls that will be 
	addressed later). What follows is the complete list of LiveControls.</p>
<table>
	<tr>
		<td valign="top">
			<ul>
				<li>
				LiveButton
				<li>
				LiveCallback
				<li>
				LiveCheckBox
				<li>
				LiveCheckBoxList
				<li>
				LiveDataGrid
				<li>
				LiveDropDownList
				<li>
					LiveHyperLink</li>
			</ul>
		</td>
		<td valign="top">
			<ul>
				<li>
				LiveImage
				<li>
				LiveImageButton
				<li>
				LiveLabel
				<li>
				LiveLinkButton
				<li>
				LiveListBox
				<li>
				LiveMessageBox
				<li>
					LivePanel</li>
			</ul>
		</td>
		<td valign="top">
			<ul>
				<li>
				LivePlaceHolder*
				<li>
				LiveRadioButton
				<li>
				LiveRadioButtonList
				<li>
				LiveSound*
				<li>
				LiveTextBox
				<li>
					LiveTimer</li>
			</ul>
		</td>
	</tr>
</table>
<p>* = The LivePlaceHolder and LiveSound controls do not initiate callbacks, but 
	are special purpose controls, the use of which is addressed later in this 
	tutorial.</p>
<p><b>Instructions:</b> Use the various Live Controls below to initiate callbacks 
	by interacting with them. Information about each callback will be shown.</p>
<table width="100%">
	<tr>
		<td colspan="2">
			<cc1:LiveLabel id="LiveLabel1" runat="server" Font-Bold="true"></cc1:LiveLabel>
		</td>
	</tr>
	<tr>
		<td>LiveButton - Click to initiate callback</td>
		<td><cc1:LiveButton id="LiveButton1" runat="server"></cc1:LiveButton></td>
	</tr>
	<tr>
		<td>LiveLinkButton - Click to initiate callback</td>
		<td><cc1:LiveLinkButton id="LiveLinkButton1" runat="server">LiveLinkButton</cc1:LiveLinkButton></td>
	</tr>
	<tr>
		<td>LiveRadioButton - Click to initiate callback</td>
		<td><cc1:LiveRadioButton id="LiveRadioButton1" runat="server" GroupName="test" Checked="true" AutoPostBack="True" Text="On"></cc1:LiveRadioButton><cc1:LiveRadioButton id="LiveRadioButton2" runat="server" GroupName="test" AutoPostBack="True" Text="Off"></cc1:LiveRadioButton></td>
	</tr>
	<tr>
		<td>LiveCheckBox - Click to initiate callback</td>
		<td><cc1:LiveCheckBox id="LiveCheckBox1" runat="server" AutoPostBack="True" Text="LiveCheckBox"></cc1:LiveCheckBox></td>
	</tr>
	<tr>
		<td>LiveDropDownList - Select to initiate callback</td>
		<td><cc1:LiveDropDownList id="LiveDropDownList1" runat="server" AutoPostBack="True">
				<asp:ListItem Value="Item 0">Item 0</asp:ListItem>
				<asp:ListItem Value="Item 1">Item 1</asp:ListItem>
				<asp:ListItem Value="Item 2">Item 2</asp:ListItem>
				<asp:ListItem Value="Item 3">Item 3</asp:ListItem>
			</cc1:LiveDropDownList></td>
	</tr>
	<tr>
		<td>LiveListBox - Select to initiate callback</td>
		<td><cc1:LiveListBox id="LiveListBox1" runat="server" AutoPostBack="True">
				<asp:ListItem Value="Item 0">Item 0</asp:ListItem>
				<asp:ListItem Value="Item 1">Item 1</asp:ListItem>
				<asp:ListItem Value="Item 2">Item 2</asp:ListItem>
				<asp:ListItem Value="Item 3">Item 3</asp:ListItem>
			</cc1:LiveListBox></td>
	</tr>
	<tr>
		<td>LiveTextBox - Modify (and tab out) to initiate callback</td>
		<td><cc1:LiveTextBox id="LiveTextBox1" runat="server" AutoPostBack="True" Text="modify this text..."></cc1:LiveTextBox></td>
	</tr>
</table>