<%@ Control Language="vb" AutoEventWireup="false" Codebehind="c)_modifying_control_styles.ascx.vb" Inherits="LiveTutorial.d_modifying_control_styles" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<%@ Register TagPrefix="cc1" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<p>
	As demonstrated in most of the other examples in this tutorial, each visual 
	LiveControl fully supports updating it's visual style (including colors, 
	borders, fonts, etc) from within a callback. This is done by simply setting the 
	commonly-used property from within a callback. For example, to change a 
	LiveLabel's background color to red, simply use a LiveControl to initiate a 
	callback (such as the LiveButton), implement an event (such as the 
	LiveButton.Click event), and set the property in the event handler</p>
<pre>
LiveLabel1.BackColor = Color.Red;
</pre>
<p><b>Instructions:</b>The following example demonstrates a small sampling of the 
	various ways a LiveControl can be modified from within a callback. Simply click 
	the radio buttons to apply the style change.</p>
<table width="100%">
	<tr>
		<td>
			<b>Background Color:</b><br>
			<cc1:LiveRadioButtonList id="lstBackColor" runat="server"></cc1:LiveRadioButtonList></td>
		<td>
			<b>Foreground Color:</b><br>
			<cc1:LiveRadioButtonList id="lstForeColor" runat="server"></cc1:LiveRadioButtonList></td>
		<td>
			<b>Font Info:</b><br>
			<cc1:LiveCheckBox id="chkBold" runat="server" Text="Bold"></cc1:LiveCheckBox><br>
			<cc1:LiveCheckBox id="chkItalic" runat="server" Text="Italic"></cc1:LiveCheckBox><br>
			<cc1:LiveCheckBox id="chkUnderline" runat="server" Text="Underline"></cc1:LiveCheckBox><br>
			<cc1:LiveCheckBox id="chkStrikeout" runat="server" Text="Strikeout"></cc1:LiveCheckBox>
		</td>
	</tr>
	<tr>
		<td>
			<b>Border Width:</b><br>
			<cc1:LiveRadioButtonList id="lstBorderWidth" runat="server"></cc1:LiveRadioButtonList></td>
		<td>
			<b>Border Style:</b><br>
			<cc1:LiveRadioButtonList id="lstBorderStyle" runat="server"></cc1:LiveRadioButtonList></td>
		<td>
			<b>Border Color:</b><br>
			<cc1:LiveRadioButtonList id="lstBorderColor" runat="server"></cc1:LiveRadioButtonList></td>
	</tr>
	<tr>
		<td colspan="3" align="middle">
			<br>
			<br>
			<cc1:LiveLabel id="LiveLabel1" runat="server" Width="300px" BorderColor="Black" BorderStyle="Solid" BorderWidth="1px">Here is the label. Click some of the buttons above to change style information about this label.</cc1:LiveLabel>
		</td>
	</tr>
</table>