<%@ Register TagPrefix="cc1" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="d)_using_the_LiveDataGrid.ascx.vb" Inherits="LiveTutorial.c_using_the_LiveDataGrid" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<p>The LiveDataGrid enhances the standard DataGrid by providing remote scripted support for all standard DataGrid actions:
</p>
<b>Callback-enabled LiveDataGrid Actions</b>
<ul>
	<li>Selecting an item.</li>
	<li>Editing/updating/cancelling an item.</li>
	<li>Deleting an item.</li>
	<li>Sorting</li>
	<li>Paging</li>
</ul>
<p>In addition, ANY changes made to the LiveData during the callback will be reflected on the client-side interface. Try the 
demo below for an example.</p>
<p><b>Instructions:</b> Interact with the grid below. Note how selecting, sorting, reverse sorting, and paging use callback
technology and do not require a page refresh.</p>
<cc1:LiveDataGrid Width="100%" id="LiveDataGrid1" runat="server" AutoGenerateColumns="False"  AllowPaging="True" AllowSorting="True">
	<HeaderStyle Font-Bold="True" BackColor="Tan"></HeaderStyle>
	<AlternatingItemStyle BackColor="PaleGoldenrod"></AlternatingItemStyle>
	<Columns>
		<cc1:LiveBoundColumn DataField="ProductID" SortExpression="ProductID" ReadOnly="True" HeaderText="Product ID">
			<ItemStyle Width="15%"></ItemStyle>
		</cc1:LiveBoundColumn>
		<cc1:LiveBoundColumn DataField="ProductName" SortExpression="ProductName" HeaderText="Product Name">
			<ItemStyle Width="38%"></ItemStyle>
		</cc1:LiveBoundColumn>
		<cc1:LiveBoundColumn DataField="QuantityPerUnit" SortExpression="QuantityPerUnit" HeaderText="Quantity Per Unit">
			<ItemStyle Width="22%"></ItemStyle>
		</cc1:LiveBoundColumn>
		<cc1:LiveBoundColumn DataField="UnitsInStock" SortExpression="UnitsInStock" HeaderText="Units In Stock">
			<ItemStyle Width="17%"></ItemStyle>
		</cc1:LiveBoundColumn>
		<cc1:LiveButtonColumn Text="Select" CommandName="Select">
			<ItemStyle Width="8%" HorizontalAlign="Center"></ItemStyle>
		</cc1:LiveButtonColumn>
	</Columns>
	<PagerStyle HorizontalAlign="Left" ForeColor="DarkSlateBlue" BackColor="PaleGoldenrod" Mode="NumericPages"></PagerStyle>
	<FooterStyle BackColor="Tan"></FooterStyle>
	<SelectedItemStyle ForeColor="DarkSlateBlue" BackColor="LightGray"></SelectedItemStyle>
</cc1:LiveDataGrid>