Imports System.Data.OleDb
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls

Namespace LiveTutorial

	''' <summary>
	'''		Summary description for c_using_the_LiveDataGrid.
	''' </summary>
	Public MustInherit Class c_using_the_LiveDataGrid
		Inherits LiveUserControl

		Protected WithEvents LiveDataGrid1 As Dart.LiveControls.LiveDataGrid

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			If NewLoad Then
				CurSortExpression = "none"
				CurSortDirection = "none"
				Try
					DoBind("", "")
				Catch ex As Exception
					Session("DataBaseError") = ex.ToString()
					Response.Redirect("DataBaseError.aspx")
				End Try
			End If
		End Sub

		Public Property CurSortExpression() As String
			Get
				Dim o As Object = Session("CurSortExpression")
				If o Is Nothing Then
					Return "ProductID"
				Else
					Return CStr(o)
				End If
			End Get
			Set(ByVal value As String)
				Session("CurSortExpression") = value
			End Set
		End Property

		Public Property CurSortDirection() As String
			Get
				Dim o As Object = Session("CurSortDirection")
				If o Is Nothing Then
					Return "asc"
				Else
					Return CStr(o)
				End If
			End Get
			Set(ByVal value As String)
				Session("CurSortDirection") = value
			End Set
		End Property

		Private Function GetConnectionString() As String
			If Not System.IO.File.Exists(CStr(Session("DataBasePath"))) Then
				Throw New Exception("Unable to locate database")
			End If
			Return "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" & CStr(Session("DataBasePath"))
		End Function

		Private Sub DoBind(ByVal sortField As String, ByVal sortDirection As String)
			Dim connection As New OleDbConnection(GetConnectionString())
			Dim sql As String = "SELECT * FROM Products"
			If sortField <> "" Then
				sql &= " ORDER BY " & sortField
			End If
			If sortField <> "" AndAlso sortDirection <> "" Then
				sql &= " " & sortDirection
			End If
'INSTANT VB NOTE: The variable adapter was renamed since Visual Basic does not handle local variables named the same as class members well:
			Dim adapter_Renamed As New OleDbDataAdapter(sql, connection)

			Dim dataSet As New DataSet("DataSetProducts")
			adapter_Renamed.Fill(dataSet, "Products")

			Dim view As DataView = dataSet.Tables("Products").DefaultView
			LiveDataGrid1.DataSource = view
			LiveDataGrid1.DataBind()
		End Sub

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			InitializeComponent()
			MyBase.OnInit(e)
		End Sub

		'''		Required method for Designer support - do not modify
		'''		the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.LiveDataGrid1.PageIndexChanged += New System.Web.UI.WebControls.DataGridPageChangedEventHandler(Me.LiveDataGrid1_PageIndexChanged)
'			Me.LiveDataGrid1.SortCommand += New System.Web.UI.WebControls.DataGridSortCommandEventHandler(Me.LiveDataGrid1_SortCommand)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		Private Sub LiveDataGrid1_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles LiveDataGrid1.PageIndexChanged
			Try
				LiveDataGrid1.CurrentPageIndex = e.NewPageIndex
				DoBind("", "")
			Catch ex As Exception
				Session("DataBaseError") = ex.ToString()
				LiveDataGrid1.BufferedScript.Write("window.location = 'DataBaseError.aspx';")
				Return
			End Try
		End Sub

		Private Sub LiveDataGrid1_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles LiveDataGrid1.SortCommand
			If CurSortExpression = "none" Then
				CurSortExpression = e.SortExpression
			End If
			If e.SortExpression = CurSortExpression Then
				If CurSortDirection = "asc" Then
					CurSortDirection = "desc"
				Else
					CurSortDirection = "asc"
				End If
			Else
				CurSortExpression = e.SortExpression
				CurSortDirection = "asc"
			End If

			Try
				DoBind(CurSortExpression, CurSortDirection)
			Catch ex As Exception
				Session("DataBaseError") = ex.ToString()
				LiveDataGrid1.BufferedScript.Write("window.location = 'DataBaseError.aspx';")
				Return
			End Try
		End Sub
	End Class
End Namespace
