Imports System.Reflection
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls

Namespace LiveTutorial

	''' <summary>
	'''		Summary description for f_using_live_list_controls.
	''' </summary>
	Public MustInherit Class f_using_live_list_controls
		Inherits LiveUserControl

		Protected WithEvents Livelistbox1 As Dart.LiveControls.LiveListBox
		Protected WithEvents Livelistbox2 As Dart.LiveControls.LiveListBox
		Protected WithEvents Livelistbox3 As Dart.LiveControls.LiveListBox
		Protected WithEvents Livelistbox4 As Dart.LiveControls.LiveListBox
		Protected LiveLabel1 As Dart.LiveControls.LiveLabel


		Private _Assembly As System.Reflection.Assembly = Nothing

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			_Assembly = Livelistbox1.GetType().Assembly

			If Not LiveLabel1.IsCallback Then
				LoadInitialListBox()
			End If
		End Sub


		Private Sub LoadInitialListBox()
			Livelistbox1.Items.Clear()
			Dim types() As Type = _Assembly.GetTypes()
			For Each type As Type In types
				If (Not type.IsSubclassOf(GetType(System.Windows.Forms.Form))) AndAlso (Not type.IsInterface) AndAlso type.IsPublic AndAlso type.IsClass AndAlso type.Namespace = "Dart.LiveControls" Then
					Livelistbox1.Items.Add(type.Name)
				End If
			Next type
		End Sub


		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			InitializeComponent()
			MyBase.OnInit(e)
		End Sub

		'''		Required method for Designer support - do not modify
		'''		the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.Livelistbox1.SelectedIndexChanged += New System.EventHandler(Me.Livelistbox1_SelectedIndexChanged)
'			Me.Livelistbox2.SelectedIndexChanged += New System.EventHandler(Me.Livelistbox2_SelectedIndexChanged)
'			Me.Livelistbox3.SelectedIndexChanged += New System.EventHandler(Me.Livelistbox3_SelectedIndexChanged)
'			Me.Livelistbox4.SelectedIndexChanged += New System.EventHandler(Me.Livelistbox4_SelectedIndexChanged)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		Private Sub Livelistbox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Livelistbox1.SelectedIndexChanged
			If Livelistbox1.SelectedIndex = -1 Then
				Return
			End If
			LiveLabel1.Text = ""
			Livelistbox2.Items.Clear()
			Livelistbox3.Items.Clear()
			Livelistbox4.Items.Clear()

			Dim className As String = Livelistbox1.SelectedItem.Text
			Dim type As Type = _Assembly.GetType("Dart.LiveControls." & className)
			CurrentType = type
			For Each propertyInfo As PropertyInfo In type.GetProperties()
				Livelistbox2.Items.Add(propertyInfo.Name)
			Next propertyInfo
			For Each methodInfo As MethodInfo In type.GetMethods()
				If methodInfo.Name.IndexOf("get_") = -1 AndAlso methodInfo.Name.IndexOf("set_") = -1 AndAlso methodInfo.Name.IndexOf("add_") = -1 AndAlso methodInfo.Name.IndexOf("remove_") = -1 Then
					Livelistbox3.Items.Add(methodInfo.Name)
				End If
			Next methodInfo
			For Each eventInfo As EventInfo In type.GetEvents()
				Livelistbox4.Items.Add(eventInfo.Name)
			Next eventInfo
		End Sub

		Private Sub Livelistbox2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Livelistbox2.SelectedIndexChanged
			If Livelistbox2.SelectedIndex = -1 Then
				Return
			End If
			If CurrentType Is Nothing Then
				Return
			End If
			Dim propertyInfo As PropertyInfo = CurrentType.GetProperty(Livelistbox2.SelectedItem.Text)

			Dim val As String = "<b>Property description:</b><br>"
			val &= "public" & GetModifier(propertyInfo.GetGetMethod()) & " " & propertyInfo.PropertyType.Name & " " & propertyInfo.Name
			val &= "{"
			If propertyInfo.CanRead Then
				val &= "get;"
			End If
			If propertyInfo.CanWrite Then
				val &= " set;"
			End If
			val &= "}"
			LiveLabel1.Text = val
		End Sub

		Private Function GetModifier(ByVal methodInfo As MethodInfo) As String
			If methodInfo.IsAbstract Then
				Return " abstract"
			End If
			If methodInfo.IsStatic Then
				Return " static"
			End If
			If methodInfo.IsVirtual Then
				Return " virtual"
			End If
			Return ""
		End Function

		Private Sub Livelistbox3_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Livelistbox3.SelectedIndexChanged
			If Livelistbox3.SelectedIndex = -1 Then
				Return
			End If
			If CurrentType Is Nothing Then
				Return
			End If
			Dim methodInfo As MethodInfo = CurrentType.GetMethod(Livelistbox3.SelectedItem.Text)
			Dim val As String = "<b>Method description:</b><br>"
			val &= "public" & GetModifier(methodInfo) & " " & methodInfo.ReturnType.Name & " " & methodInfo.Name
			val &= "("
			For Each param As ParameterInfo In methodInfo.GetParameters()
				val &= param.ParameterType.Name & " " & param.Name & ", "
			Next param
			If val.EndsWith(", ") Then
				val = val.Substring(0, val.Length-2)
			End If
			val &= ")"
			LiveLabel1.Text = val
		End Sub

		Private Sub Livelistbox4_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Livelistbox4.SelectedIndexChanged
			If Livelistbox4.SelectedIndex = -1 Then
				Return
			End If
			If CurrentType Is Nothing Then
				Return
			End If
			Dim eventInfo As EventInfo = CurrentType.GetEvent(Livelistbox4.SelectedItem.Text)
			Dim val As String = "<b>Event description:</b><br>"
			val &= "public event " & eventInfo.EventHandlerType.Name & " " & eventInfo.Name
			LiveLabel1.Text = val
		End Sub

		Public Property CurrentType() As Type
			Get
				Dim o As Object = Session("CurrentType")
				If o Is Nothing Then
					Return Nothing
				Else
					Return CType(o, Type)
				End If
			End Get
			Set(ByVal value As Type)
				Session("CurrentType") = value
			End Set
		End Property
	End Class
End Namespace
