Imports Dart.LiveControls
Imports System.Collections
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls

Namespace LiveTutorial

	''' <summary>
	'''		Summary description for f_using_LiveSound.
	''' </summary>
	Public MustInherit Class f_using_LiveSound
		Inherits LiveUserControl

		Protected lblMachine1 As Dart.LiveControls.LiveLabel
		Protected lblMachine3 As Dart.LiveControls.LiveLabel
		Protected lblMachine4 As Dart.LiveControls.LiveLabel
		Protected WithEvents btnStart As Dart.LiveControls.LiveButton
		Protected WithEvents btnStop As Dart.LiveControls.LiveButton
		Protected LiveSound1 As Dart.LiveControls.LiveSound
		Protected WithEvents LiveTimer1 As Dart.LiveControls.LiveTimer
		Protected LiveMessageBox1 As Dart.LiveControls.LiveMessageBox
		Protected WithEvents btnReset As Dart.LiveControls.LiveButton
		Protected lblMachine2 As Dart.LiveControls.LiveLabel


		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' Put user code to initialize the page here
			If NewLoad Then
				'LiveTimer1.Interval = 500;
				lblMachine4.Text = ""
				lblMachine3.Text = lblMachine4.Text
				lblMachine2.Text = lblMachine3.Text
				lblMachine1.Text = lblMachine2.Text
			End If
		End Sub

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			InitializeComponent()
			MyBase.OnInit(e)
		End Sub

		'''		Required method for Designer support - do not modify
		'''		the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.btnStart.Click += New System.EventHandler(Me.btnStart_Click)
'			Me.btnStop.Click += New System.EventHandler(Me.btnStop_Click)
'			Me.btnReset.Click += New System.EventHandler(Me.btnReset_Click)
'			Me.LiveTimer1.Tick += New System.EventHandler(Me.LiveTimer1_Tick)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region

		Private Sub btnStart_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnStart.Click
			LiveTimer1.Start()
		End Sub

		Private Sub btnStop_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnStop.Click
			LiveTimer1.Stop()
		End Sub

		Public Property MaxTemps() As ArrayList
			Get
				Dim o As Object = Session("MaxTemps")
				If o Is Nothing Then
					o = CreateMaxTemps()
					Session("MaxTemps") = o
				End If
				Return CType(o, ArrayList)
			End Get
			Set(ByVal value As ArrayList)
				Session("MaxTemps") = value
			End Set
		End Property

		Public Property CurTemps() As ArrayList
			Get
				Dim o As Object = Session("CurTemps")
				If o Is Nothing Then
					o = CreateInitialTemps()
					Session("CurTemps") = o
				End If
				Return CType(o, ArrayList)
			End Get
			Set(ByVal value As ArrayList)
				Session("CurTemps") = value
			End Set
		End Property

		Private Function CreateInitialTemps() As ArrayList
			Dim temps As New ArrayList()
			temps.Add(500)
			temps.Add(400)
			temps.Add(300)
			temps.Add(600)
			Return temps
		End Function

		Private Function CreateMaxTemps() As ArrayList
			Dim temps As New ArrayList()
			temps.Add(530)
			temps.Add(500)
			temps.Add(400)
			temps.Add(800)
			Return temps

		End Function

		Private Sub LiveTimer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LiveTimer1.Tick
			If LiveTimer1.Enabled Then
				SetNewTemps()
				UpdateInterface()
				CheckForDanger()
			End If
		End Sub

		Private Sub SetNewTemps()
			' "fake" modification of the current temps...need to make sure at least one 
			' always goes up...so the user will not have to wait forever for the sound to go off

			' get the sign first

			Dim sign As Integer
			If Randomize(0, 2) = 0 Then
				sign = (-1)
			Else
				sign = (1)
			End If

			' now get the modifiers
			Dim mod1 As Integer = Randomize(0, 11)
			Dim mod2 As Integer = Randomize(0, 11)
			Dim mod3 As Integer = Randomize(0, 11)
			Dim mod4 As Integer = Randomize(0, 11)

			' Add the sign and the modifier to machine 1, 2, and 4....these will fluctuate.
			Dim val As Integer = CInt(Fix(CurTemps(0)))
			CurTemps(0) = val + (sign * mod1)
			val = CInt(Fix(CurTemps(1)))
			CurTemps(1) = val + (sign * mod2)
			val = CInt(Fix(CurTemps(3)))
			CurTemps(3) = val + (sign * mod4)

			' Machine 3 will get the modifier only...SOMETHING IS WRONG WITH THIS MACHINE!!!!!!!
			val = CInt(Fix(CurTemps(2)))
			CurTemps(2) = val + mod3
		End Sub

		Private Function Randomize(ByVal min As Integer, ByVal max As Integer) As Integer
			System.Threading.Thread.Sleep(5)
			Dim rand As New Random()
			Return rand.Next(min, max)
		End Function

		Private Sub UpdateInterface()
            lblMachine1.Text = CurTemps(0).ToString() & " degrees"
            lblMachine2.Text = CurTemps(1).ToString() & " degrees"
            lblMachine3.Text = CurTemps(2).ToString() & " degrees"
            lblMachine4.Text = CurTemps(3).ToString() & " degrees"
		End Sub

		Private Sub CheckForDanger()
			For i As Integer = 0 To CurTemps.Count - 1
				Dim cur As Integer = CInt(Fix(CurTemps(i)))
				Dim max As Integer = CInt(Fix(MaxTemps(i)))
				If cur > max Then
					' DANGER...notify someone
					If i = 0 Then
						TakeDangerAction(lblMachine1)
					End If
					If i = 1 Then
						TakeDangerAction(lblMachine2)
					End If
					If i = 2 Then
						TakeDangerAction(lblMachine3)
					End If
					If i = 3 Then
						TakeDangerAction(lblMachine4)
					End If
				End If
			Next i
		End Sub

		Private Sub TakeDangerAction(ByVal label As Dart.LiveControls.LiveLabel)
			Dim alreadyAlerted As Boolean = label.BackColor = Color.Red
			label.BackColor = Color.Red
			label.Text = label.Text & " OVERHEATED! CHECK NOW!"
			label.Font.Bold = True
			label.ForeColor = Color.White
			If alreadyAlerted Then
				Return
			End If
			LiveSound1.Play()
		End Sub

		Private Sub btnReset_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReset.Click
			LiveTimer1.Stop()
			CurTemps = CreateInitialTemps()
			resetLabel(lblMachine1)
			resetLabel(lblMachine2)
			resetLabel(lblMachine3)
			resetLabel(lblMachine4)
		End Sub

		Private Sub resetLabel(ByVal label As LiveLabel)
			label.BackColor = Color.Empty
			label.ForeColor = Color.Empty
			label.Font.Bold = False
			label.Text = ""
		End Sub
	End Class
End Namespace
