<%@ Register TagPrefix="cc2" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<%@ Control Language="vb" AutoEventWireup="false" Codebehind="b)_interacting_with_3rd_party_controls.ascx.vb" Inherits="LiveTutorial.b_interacting_with_3rd_party_controls" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<%@ Register TagPrefix="cc1" Namespace="MSPress.ServerComponents" Assembly="ImageLabelControl" %>
<p>Live Controls can also update <i>most</i> 3rd party controls. A common type of 
	3rd party control that Live Controls can NOT update is one which generates 
	configuration JavaScript <i>outside</i> of the HTML tags which comprise the 
	server control output. Even then, often this can be worked around by updating 
	the appropriate javascript manually.</p>
<p>The following server control (the ImageLabel) was written by Nikjil Kothari and 
	Vandana Datye of Microsoft Press in their book <u>Developing Microsoft ASP.NET 
		Server Controls and Components.</u> This server control dynamically creates 
	and displays an image based on provided criteria. A few minor alterations were 
	made (such as adding gradient support) to provide a little more visual impact 
	for demonstration purposes. It will serve the purpose of a "3rd Party" server 
	control.</p>
<p><b>Instructions:</b> Make some modifications in the following form fields. With 
	each change, a callback is made to the server, updating the image.</p>
<table border="0">
	<tr>
		<td>Text:</td>
		<td><cc2:livetextbox id="txtText" runat="server" AutoPostBack="True">Test Image</cc2:livetextbox>
		</td>
		<td>(tab out of this field to update)</td>
	</tr>
	<tr>
		<td>Text color:</td>
		<td colspan="2"><cc2:livedropdownlist id="ddTextColor" runat="server" Width="200px" AutoPostBack="True"></cc2:livedropdownlist></td>
	</tr>
	<tr>
		<td>Font name:</td>
		<td colspan="2"><cc2:livedropdownlist id="ddFontName" runat="server" Width="200px" AutoPostBack="True"></cc2:livedropdownlist></td>
	</tr>
	<tr>
		<td>Gradient color 1:</td>
		<td colspan="2"><cc2:livedropdownlist id="ddGradientColor1" runat="server" Width="200px" AutoPostBack="True"></cc2:livedropdownlist></td>
	</tr>
	<tr>
		<td>Gradient color 2:</td>
		<td colspan="2"><cc2:livedropdownlist id="ddGradientColor2" runat="server" Width="200px" AutoPostBack="True"></cc2:livedropdownlist></td>
	</tr>
</table>
<div align="center"><cc1:imagelabel EnableViewState="false" id="ImageLabel1" runat="server" ImageLabelHandlerUrl="ImageLabel.ashx" LiveControlUpdate="true"></cc1:imagelabel></div>