Imports System.Collections
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls

Namespace LiveTutorial

	''' <summary>
	'''		Summary description for b_interacting_with_3rd_party_controls.
	''' </summary>
	Public MustInherit Class b_interacting_with_3rd_party_controls
		Inherits LiveUserControl

		Protected WithEvents txtText As Dart.LiveControls.LiveTextBox
		Protected WithEvents ddTextColor As Dart.LiveControls.LiveDropDownList
		Protected WithEvents ddFontName As Dart.LiveControls.LiveDropDownList
		Protected WithEvents ddGradientColor1 As Dart.LiveControls.LiveDropDownList
		Protected WithEvents ddGradientColor2 As Dart.LiveControls.LiveDropDownList
		Protected ImageLabel1 As MSPress.ServerComponents.ImageLabel

		Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' Put user code to initialize the page here
			If NewLoad Then
				' Put user code to initialize the page here
				ImageLabel1.Width = New Unit("400px")
				ImageLabel1.Height = New Unit("200px")
				ImageLabel1.BackColor = Color.White
				ImageLabel1.BackColor2 = Color.White
				ImageLabel1.Text = "Test Image"

				' Load drop down values 
				Dim colors As ArrayList = GetColors()
				ddGradientColor1.DataSource = colors
				ddGradientColor1.DataBind()
				ddGradientColor2.DataSource = colors
				ddGradientColor2.DataBind()
				ddTextColor.DataSource = colors
				ddTextColor.DataBind()
				ddTextColor.SelectedIndex = 1
				ddFontName.DataSource = GetFontNames()
				ddFontName.DataBind()
			End If
		End Sub

		#Region "Web Form Designer generated code"
		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			'
			' CODEGEN: This call is required by the ASP.NET Web Form Designer.
			'
			InitializeComponent()
			MyBase.OnInit(e)
		End Sub

		'''		Required method for Designer support - do not modify
		'''		the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
'			Me.txtText.TextChanged += New System.EventHandler(Me.txtText_TextChanged)
'			Me.ddTextColor.SelectedIndexChanged += New System.EventHandler(Me.ddTextColor_SelectedIndexChanged)
'			Me.ddFontName.SelectedIndexChanged += New System.EventHandler(Me.ddFontName_SelectedIndexChanged)
'			Me.ddGradientColor1.SelectedIndexChanged += New System.EventHandler(Me.ddGradientColor1_SelectedIndexChanged)
'			Me.ddGradientColor2.SelectedIndexChanged += New System.EventHandler(Me.ddGradientColor2_SelectedIndexChanged)
'			Me.Load += New System.EventHandler(Me.Page_Load)

		End Sub
		#End Region


		Private Function GetFontNames() As ArrayList
			Dim names As New ArrayList()
			names.Add("Serif")
			names.Add("Impact")
			names.Add("Courier")
			names.Add("Arial")
			names.Add("Tahoma")
			names.Add("Terminal")
			names.Add("Comic Sans MS")
			Return names
		End Function

		Private Function GetColors() As ArrayList
			Dim colors As New ArrayList()
			colors.Add("White")
			colors.Add("Black")
			colors.Add("Aqua")
			colors.Add("Blue")
			colors.Add("Fuchsia")
			colors.Add("Gray")
			colors.Add("Green")
			colors.Add("Lime")
			colors.Add("Maroon")
			colors.Add("Navy")
			colors.Add("Olive")
			colors.Add("Purple")
			colors.Add("Red")
			colors.Add("Silver")
			colors.Add("Teal")
			colors.Add("Yellow")
			Return colors
		End Function

		Private Sub txtText_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtText.TextChanged
			UpdateImage()
		End Sub

		Private Sub ddTextColor_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddTextColor.SelectedIndexChanged
			UpdateImage()
		End Sub

		Private Sub ddFontName_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddFontName.SelectedIndexChanged
			UpdateImage()
		End Sub

		Private Sub ddGradientColor1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddGradientColor1.SelectedIndexChanged
			UpdateImage()
		End Sub

		Private Sub ddGradientColor2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddGradientColor2.SelectedIndexChanged
			UpdateImage()
		End Sub

		Private Sub UpdateImage()
			ImageLabel1.Text = txtText.Text
			ImageLabel1.ForeColor = System.Drawing.ColorTranslator.FromHtml(ddTextColor.SelectedItem.Text)
			ImageLabel1.Font.Name = ddFontName.SelectedItem.Value
			ImageLabel1.BackColor = System.Drawing.ColorTranslator.FromHtml(ddGradientColor1.SelectedItem.Text)
			ImageLabel1.BackColor2 = System.Drawing.ColorTranslator.FromHtml(ddGradientColor2.SelectedItem.Text)
		End Sub
	End Class
End Namespace
