<%@ Control Language="vb" AutoEventWireup="false" Codebehind="a)_implementing_custom_callbacks.ascx.vb" Inherits="LiveTutorial.a_implementing_custom_callbacks_with_LiveCallback" TargetSchema="http://schemas.microsoft.com/intellisense/ie5"%>
<%@ Register TagPrefix="cc1" Namespace="Dart.LiveControls" Assembly="Dart.LiveControls" %>
<p>While LiveControls encapsulate nearly every type of callback possible when 
	creating web forms, there are unique cases that require a more custom solution. 
	In these cases, the LiveCallback object can be used to call a server function, 
	pass any number of arguments, and get the response from the function.
</p>
<p>The following example demonstrates a web "autosave" feature. Every 10 characters 
	typed into the TextBox causes a callback to be sent to the server, enabling the 
	developer to save the text typed so far into the database. This is useful in a 
	web app because if the client browser or webserver crashes, the data typed so 
	far can be easily restored when the user reloads the page.
</p>
<p><b>Instructions:</b> Type some characters into the textbox below. Every 10 
	characters, a callback will be sent to the server updating the database with 
	the data typed so far.
</p>
<br>
<cc1:LiveTextBox id="LiveTextBox1" style="WIDTH: 600px; HEIGHT: 260px" runat="server"  TextMode="MultiLine" AutoPostBack="False"></cc1:LiveTextBox><br>
<cc1:livelabel EnableViewState="False" id="lblResults" runat="server"></cc1:livelabel><br>
<cc1:livecallback id="LiveCallback1" runat="server"></cc1:livecallback>